// HP 48 Program Development Link Application
//
/Angle Degrees
/FractionMark .
/InstallDir
/AutoExec
//
/Var \->\->NOTES
@ MONEY PROGRAMS

@   \>>\>>\>> using a simple 2 item list \<<\<<\<<
@  ACCT start program
@  act1 +/- to acct 1
@ act12 xfr acct 1 to 2
@ act1r acct 1 recall
@  act2 +/- to acct 2
@ act21 xfr acct 2 to 1
@ act2r acct 2 recall
@  actd display
@  acct data
@  actm tmenu data

@   \>>\>>\>> using the statistics system & a companion list \<<\<<\<<
@   \>>\>>\>> up to 8 entries displayed on the graphics screen \<<\<<\<<
@   \>>\>>\>> more entries can be used by increasing the graphics area \<<\<<\<<
@ \GSDISP display
@  \GSENT make an entry
@  \GSRST reset \GSDAT & \GSLBL with balance at the top
@  \GSDAT data
@  \GSLBL companion list

@   \>>\>>\>> misc stuff \<<\<<\<<
@    $$ custom menu
@  COMP compare the two account systems
@  PPAR plot parameters
@  \GSPAR \GS parameters

@   \>>\>>\>> TVM \<<\<<\<<
@    FV future value
@  I%YR % per year
@     N # payments
@   PMT payment
@    PV present value
@   PYR payments per year
//
/Var $$
{ MAIN CLKMNU \GSDISP
\GSENT \GSRST ACCT COMP
\GSX \GSY { "TVM"
\<< 79 MENU
\>> } UTIL }
//
/Var \GSDAT
@ statistics data
[
   [  198.92  22.78 ]
   [ -175    175    ]
]
//
/Var \GSDISP
@ graphic display of \GSDAT
@ uses: RJST, GDISP, & \GSLBL
@ new version using PAD0 instead of RJST
@ Gives more room for labels
\<<
   CLLCD
      # 83h # 40h PDIM                 @ clear graphics screen
      { # 0h # 0h } PVIEW              @ show graphics screen
      9 17                             @ column positions
      RCLF 1
      2 save flags
      \-> a b f r
   \<<
      CLUFL                            @ clear user flags
      4 SF                             @ pad with spaces
      2 FIX                            @ financial precision
      '\GSDAT' { 1 1 }                 @ statistics & starting index
      DO
         \-> i
         \<<
            i 1 GET 'r' STO            @ save row #
            i
            GETI 4 PAD0 1 r 1 GDISP    @ get first #
            GETI 4 PAD0 1 r a GDISP    @ get second #
            '\GSLBL' r GET 1 r b GDISP  @ get label
         \>>
      UNTIL
         -64 FS?
      END
      DROP2                            @ clear stack
      \GSX 4 PAD0 1 r 1 + 1 GDISP      @ get sum of first #'s
      \GSY 4 PAD0 1 r 1 + a GDISP      @ get sum of second #'s
      "<" 34 b - RPT 1 r 1 + b GDISP   @ divider
      f STOF                           @ restore flags
      { } PVIEW                        @ stay on graphics screen
   \>>
\>>
//
/Var \GSENT
@ account entry
\<<
   RCLF
   \->  f
   \<<
      CLLCD
      RECT -19 CF                      @ set vector modes
      "\GS Entry"                      @ INPUT title
      ":A1:0" 10 CHR +                 @ build INPUT string
      ":A2:0" 10 CHR + +
      DATE 0 TSTR 5 12 SUB "TX" \->TAG +
      { -1 5 } V 3 \->LIST INPUT       @ INPUT
      OBJ\->                           @ get data
      DTAG N\GS \->TAG                 @ tag \GSLBL entry
      \GSLBL SWAP + '\GSLBL' STO       @ save \GSLBL entry
      \->V2 \GS+                       @ save \GSDAT entry
      f STOF
      \GSDISP                          @ display account
   \>>
\>>
//
/Var \GSLBL
@ companion list
{
   ":0: BEG BAL"
   ":1: 22.042015"
}
//
/Var \GSPAR
@ default statistics parameters
{
   1 2 0 0 LINFIT
}
//
/Var \GSRST
@ reset \GSDAT
@ uses: \GSDISP & \GSLBL
\<<
   CLLCD                               @ clear display
   \GSX \GSY                           @ sums
   CL\GS                               @ clear statistics
   \->V2 \GS+                          @ save sums
   \GSLBL 1 1 SUB '\GSLBL' STO         @ reset companion list
   \GSDISP                             @ display \GSDAT
\>>
//
/Var acct
@ account data
{
   23.92
   197.78
}
//
/Var ACCT
@ start account
@ uses: actm & actd
\<<
   actm TMENU actd
\>>
//
/Var act1
@ account 1 entry
@ used by: actm
@ uses: acr1r & acct
\<<
   act1r + 'acct' 1 ROT PUT
\>>
//
/Var act12
@ account 1 to 2 transfer
@ used by: actm
@ uses: act1 & act2
\<<
   \-> n
   \<<
      n NEG act1 n act2
   \>>
\>>
//
/Var act1r
@ account 1 recall
@ used by: actm
@ uses: acct
\<<
   'acct' 1 GET
\>>
//
/Var act2
@ account 2 entry
@ used by: actm
@ uses: acr2r & acct
\<<
   act2r + 'acct' 2 ROT PUT
\>>
//
/Var act21
@ account 2 to 1 transfer
@ used by: actm
@ uses: act1 & act2
\<<
   \-> n
   \<<
      n NEG act2 n act1
   \>>
\>>
//
/Var act2r
@ account 2 recall
@ used by: actm
@ uses: acct
\<<
   'acct' 2 GET
\>>
//
/Var actd
@ account display
@ updated to display generic data for second account
\<<
   14 RCLF 'acct'
   \-> n f a
   \<<
      CLLCD 2 FIX
      "0-01-61-205190" 3 DISP a 1 GET n 5 SF RJST 4 DISP
      ">Cash On Hand<" 6 DISP a 2 GET n 5 SF RJST 7 DISP
      2 FREEZE
      f STOF
   \>>
\>>
//
/Var actm
@ account tmenu
{
   { "\<-1\->" act1r }
   { "\->1\<-" \<< act1  actd \>> }
   { "\->1\->" \<< act12 actd \>> }
   { "\<-2\<-" \<< act21 actd \>> }
   { "\->2\<-" \<< act2  actd \>> }
   { "\<-2\->" act2r }
}
//
/Var COMP
@ compare the two account systems
\<<
   acct \GSX \GSY 2 \->LIST
\>>
//
/Var CST
'$$'
//
/Var FV
0
//
/Var I%YR
5
//
/Var N
180
//
/Var PMT
-500
//
/Var PPAR
@ plot default parmeters
{
   (-6.5,-3.1) (6.5,3.2) X 0 (0,0) FUNCTION Y
}
//
/Var PV
52000
//
/Var PYR
12
