// HP 48 Program Development Link Application
//
/Angle Degrees
/FractionMark .
/InstallDir { HOME MAIN PLOT SOLVE }
/AutoExec
//
/Var \->\->NOTES
@ solve & TVM

@ > > > programs
@  AMTN find principal > interest
@  AMTP print amtn
@  AMTS print tvm vars
@  AMTT print all
@  EXCO expand & collect
@ RESET reset directory, deletes everything not in 'reset' list
@ SOLVR start solver
@   TAX tax calculations
@  amtn calc principal & interest

@ > > > variables
@ FV I%YR N PMT PV PYR
@ reset
@ tax

@ > > > misc
@ solve custom menu

@ > > > tvm equation
@ I% tvm
//
/Var AMTN
@ find principal > interest
\<<
   CLLCD
   1 N
   FOR I
      I 1 DISP
      IF I amtn ABS SWAP ABS \<=
      THEN
         I N 'I' STO
      END
   NEXT
\>>
//
/Var amtn
@ calc principal & interest
\<<
   \-> I
   \<<
      I 1 - AMORT DROP I AMORT DROP
      \-> P1 I1 P2 I2
      \<<
         P2 P1 - "P" \->TAG I2 I1 - "I" \->TAG
      \>>
   \>>
\>>
//
/Var AMTP
@ print amtn
\<<
   CLLCD
   "\|>" OVER + PR1 1 DISP
   amtn SWAP PR1 2 DISP
   PR1 3 DISP
\>>
//
/Var AMTS
@ print tvm vars
\<<
   CLLCD RCLF
   \-> f
   \<<
      2 FIX
      5 CF
      "MODE"
      IF -14 FS?
      THEN
         "BEG"
      ELSE
         "END"
      END
      10 RJST + PR1 1 DISP
      { N PYR I%YR PV FV PMT }
      1
      \<<
         rcl OBJ\-> 4 RJST SWAP str\<- 10 RJST +
         PR1
         NSUBS 1 + DISP
      \>>
      DOSUBS
      f STOF
   \>>
\>>
//
/Var AMTT
@ print all
\<<
   AMTS 3 WAIT AMTN CR AMTP 3 WAIT
\>>
//
/Var EXCO
@ ex[and & collect
\<<
   CLLCD DUP
   DO
      \-> E
      \<<
         E DUP 2 DISP EXPAN E OVER
      \>>
   UNTIL SAME
   END
   DO
      \-> E
      \<<
         E DUP 4 DISP COLCT E OVER
      \>>
   UNTIL SAME
   END
\>>
//
/Var RESET
@ reset directory
\<<
   CLLCD RCLF
   "Reset Directory" 1 DISP
   STD
   VARS                                @ variables
   1
   \<<
      \-> X
      \<<
         NSUB "/" + ENDSUB + 3 DISP
         X 5 DISP "" 6 DISP
         1 CF
         reset                         @ variables to ignore
         1
         \<<
            IF X SAME
            THEN
               1 SF
            END
         \>>
         DOSUBS
         IF 1 FC?
         THEN
            "Purge" 6 DISP X
            IFERR PURGE
            THEN
               PGDIR
            END
            .5 WAIT
         END
      \>>
   \>>
   DOSUBS
   STOF
\>>
//
/Var reset
@ reset list
{
   AMTN  AMTP AMTS AMTT BKP   CST
   EQ    EXCO FV   I%   I%YR  Mpar
   N     PMT  PPAR PV   PYR   RESET
   SOLVR TAX  ZPAR amtn reset solve
   tax   tvm  \GSPAR
}
//
/Var solve
@ solve menu & tax system
{
   PLOT view
   {
      "TAX"
      \<<
         { CL\GS \GSDAT \GS+ \GS- TAX { "%" tax } }
         TMENU
      \>>
   }
   TVM AMTN AMTT
   SOLVR EXCO RESET PRPICT UTIL
}
//
/Var SOLVR
@ start solver
\<<
   30 MENU
\>>
//
/Var TAX
@ tax calculation
@ uses custom menu
\<<
   TOT "\GS" \->TAG tax OVER * "%" \->TAG OVER OVER + "T" \->TAG
\>>
//
/Var tax
@ tax rate
.07
