// HP 48 Program Development Link Application
//
/Angle Degrees
/FractionMark .
/InstallDir { HOME MAIN PLOT }
/AutoExec
//
/Var \->\->NOTES
@ plotting stuff

@ > > > directories
@ CALC   calculus stuff
@ POLY   polynomial stuff, new to the HP48GX and very nice!
@ SOLVE  solve stuff, TVM here

@ > > > programs
@ atick get current atick
@ centr get current center
@  pdim set pdim
@   pos get view position for large screens
@ scale get current scale
@  view view dialog box

@ > > > misc
@  plot custom menu

@ > > > some utilities are in the HOME directory
@ HLINE horizontal line at Y with N spacing
@  MARK mark at (x,y)
@ P.PRN graphics sizes
@ P.SPL "
@ P.SQR "
@ P.STD "
@ VLINE vertical line at X with N spacing
@  VIEW view utilities
@ VIEW0 "
@ VIEW3 "
@ VIEW7 "
//
/Var atick
@ get current atick
\<<
   'PPAR' 5 GET
   IF DUP TYPE 5 ==
   THEN
      2 GET
   ELSE
      DROP # Ah "Default" \->TAG
   END
\>>
//
/Var centr
@ get current center
\<<
   PICT SIZE 2 \->LIST 2 / PX\->C
\>>
//
/Var pdim
@ set pdim
\<<
   "PICT: " PICT SIZE " " SWAP + + +
   {
      { "STD #83h #40h" 1 }
      { "PRN #A6h #40h" 2 }
      { "SQR #83h #83h" 3 }
      { "SPL #A6h #80h" 4 }
   } 1
   IF CHOOSE
   THEN
      \-> i
      \<<
         CASE
            i 1 ==
            THEN
               P.STD
            END
            i 2 ==
            THEN
               P.PRN
            END
            i 3 ==
            THEN
               P.SQR
            END
            i 4 ==
            THEN
               P.SPL
            END
         END
      \>>
   END
\>>
//
/Var pos
@ get view position for large screens
\<<
   IF DUP TYPE 1 ==
   THEN
      C\->PX
   END
   PICT SIZE 2 \->LIST
   DUP
   { # 82h # 3Fh }
   - ROT * SWAP /
\>>
//
/Var scale
@ get current scal
\<<
   IFERR 'PPAR' 1 GETI
   THEN
      DROP2 "No PPAR" CLLCD 3 DISP 2 FREEZE
   ELSE
      3 ROLLD GET
      SWAP - C\->R PICT SIZE B\->R 1 - 10 /
      SWAP B\->R 1 - 10 / 4
      ROLL SWAP / 3
      ROLLD /
   END
\>>
//
/Var TMP
"Test InstallDir"
//
/Var saw0
@ true saw
'1-X/\pi-2*IP((1-X/\pi+SIGN(1-X/\pi))/2)'
//
/Var saw1
@ saw 1
'SIN(X+SIN(X))'
//
/Var saw2
@ saw 2
'SIN(X+SIN(-1*X))'
//
/Var sin
@ sine
'SIN(X)'
//
/Var sqr
@ square
'SIN(X+SIN(2*X))'
//
/Var sqr0
@ true square
'SIGN(SIN(X))'
//
/Var tri
@ triangle
'SIN(X+.5*SIN(-2*X))'
//
/Var tri0
@ ture triangle
'SIGN(COS(X))*(2/\pi*X-2*IP((2/\pi*X+SIGN(2/\pi*X))/2))'
//
/Var TRIG
@ trig functions
\<<
   DEG
   # 83h # 83h PDIM
   # 1h RES
   'trig' STEQ
   30 .5 SCALE
   (180,0) CENTR
   -28 SF -31 SF
   DRAX DRAW
   play
   { } PVIEW
\>>
//
/Var trig
@ used by: TRIG
{ 'SIN(X)' 'COS(X)'
'TAN(X)' }
