// HP 48 Program Development Link Application
//
/Angle Degrees
/FractionMark .
/InstallDir
/AutoExec
//
/Var \->\->NOTES
@ alarm utilities

@      AALM display all alarms
@     ADISP display alarm #, list, or message
@     adisp display alarm list
@     ADVAL advance alarm #1 by one month
@ findalarm finds alarm message
@      FLAG set various alarm flags
@      GALM graphic display of all alarms
@      NALM get # of alarms
@    NXTALM DDAYS until next alarm tagged with message

@     alarm CST menu
@    flgmnu FLAG menu
//
/Var AALM
@ display all alarms
\<<
   CLLCD 0
   \-> i
   \<<
      "All Alarm Display" 3 DISP
      DO
         IFERR
            'i' INCR RCLALARM
         THEN                          @ leave nonexistant alarm # on stack
         ELSE
            adisp                      @ diaplay alary list
            i "ALM" \->TAG 7 DISP      @ display alarm #
            0 WAIT DROP
            0                          @ continue DO loop
         END
      UNTIL
      END
   \>>
\>>
//
/Var adisp
@ display alarm list
\<<
   OBJ\-> DROP
   \-> d t m r
   \<<
      d t TSTR 4 DISP
      m "MSG" \->TAG 5 DISP
      r "RPT" \->TAG 6 DISP
   \>>
\>>
//
/Var ADISP
@ display alarm
@ #, aarm list, message
\<<
   DUP TYPE \-> a t
   \<<
      CLLCD
      CASE                             @ if lst or msg find #
         t 5 ==                        @ lst
         THEN
            a 3 GET findalarm 'a' STO
         END
         t 2 == t 6 == OR              @ message obj / str
         THEN
            a findalarm 'a' STO
         END
      END
      IFERR                            @ rcl #
         a RCLALARM
      THEN
         DROP "Not Found" 4 DISP
      ELSE
         adisp a "ALM" \->TAG 7 DISP   @ disp alm w/alm #

      END
      2 FREEZE
   \>>
\>>
//
/Var ADVAL
@ advance alarm #1 1 month
\<<
   CLLCD 1 RCLALARM
   \-> a
   \<<
      "Advance Alarm" 3 DISP
      a adisp                          @ display alarm
      3 WAIT
      -44 SF                           @ save past due alarms
      a                                @ for later PUT
      a 1 GET DMY                      @ get date
      \-> d m y
      \<<
         IF
            'm' INCR 12 >              @ increment month
         THEN                          @ month & year wrap
            1 'y' STO+                 @ increment year
            1 'm' STO                  @ reset month
         END
         d m y DMY\->                  @ build date
      \>>
      1 SWAP PUT                       @ put new date
      1 DELALARM                       @ delete alarm
      STOALARM                         @ save alarm
      DROP                             @ delete alarm index
   \>>
\>>
//
/Var alarm
{ TIMEF AALM ADISP
ADVAL NXTALM
RCLALARM findalarm
CLKMNU FLAG UTIL }
//
/Var findalarm
@ does what FINDALARM will not
@ searches messages for match
@ index # = found; 0 = not found
\<<
   0
   \-> f i
   \<<
      DO
         IFERR
            'i' INCR RCLALARM
         THEN
            0 SWAP
         ELSE
            IF
               3 GET f SAME
            THEN
               i DUP
            ELSE
               0
            END
         END
      UNTIL
      END
   \>>
\>>
//
/Var FLAG
\<< "CLK" -40 1
flgstr "24H" -41 2
flgstr "DMY" -42 3
flgstr "BEP" -56 4
flgstr "ALM" -57 5
flgstr 5 \->LIST
'flgmnu' STO flgmnu
TMENU
\>>
//
/Var GALM
@ graphic display of all alarms
@ uses: NALM
\<<
   CLLCD
   0                                   @ list index
   RCLF                                @ save flags
      \-> i f
   \<<
      # 83h # 40h NALM 10.5 / CEIL * PDIM  @ adjust graph for # alarms
      { # 0h # 0h } PVIEW              @ activate graphics view
      DO
         IFERR
            'i' INCR RCLALARM
         THEN
         ELSE
            OBJ\-> DROP2               @ clear list # & repeat #
            1 i  25 GDISP              @ alarm message
            TSTR TSTR\->               @ break apart TSTR
            1 i  17 GDISP              @ time
            1 i  9 GDISP               @ date
            1 i  4 GDISP               @ dow
            i 2 PAD0 1 i  1 GDISP      @ #
            0
         END
      UNTIL
      END
      f STOF                           @ restore flags
      { } PVIEW                        @ remain in graphics view
   \>>
\>>
//
/Var NALM
@ get # of alarms
\<<
   0 \-> i                             @ alarm index
   \<<
      DO
         IFERR                         @ get alarm
            'i' INCR RCLALARM
         THEN                          @ if no alarm leave DO flag & index
            DUP
         ELSE                          @ if alarm DROP & leave DO flag
            DROP 0
         END
      UNTIL
      END
      1 -                              @ -1 from not found index
   \>>
\>>
//
/Var NXTALM
@ DDAYS until next alarm tagged with message
@ new version shows all alarms
@ leaves alarms on stack in ascending order
\<<
   0 \-> i                             @ INDEX
   \<<
      64 CF                            @ clear exit flag
      DO
         IFERR
            'i' INCR RCLALARM
         THEN                          @ clear stack & set exit flag
            DROP 64 SF
         ELSE                          @ process alarm
            OBJ\-> DROP
            \-> d t m r
            \<<
               DATE d DDAYS            @ calc days to alarm
               '1_d' \->UNIT           @ make unit
               m \->TAG                @ tag message
               i ROLLD                 @ invert stack
            \>>
         END
      UNTIL
         64 FS?
      END
   \>>
\>>
