// HP 48 Program Development Link Application
//
/Angle Degrees
/FractionMark .
/InstallDir { HOME MAIN TIMEF }
/AutoExec
//
/Var \->\->NOTES
@ time functions

@       \>>> current programs \<<<
@       AGE my age
@      DOY\-> doy to date
@      DOY\<- date to doy
@       DST dst clock
@      date tagged date
@       dow date to dow (1=M)
@      tstr time string
@       age age data

@       \>>\>>\>> utilities \<<\<<\<<
@     CALEN graphical calendar starting week before current date
@    clkadj adjust clock with menu
@    CLKMNU clock menu
@     CLOCK bar clock
@       DAY given date return day of year
@           01.01yyyy = 1
@           31.12yyyy = 365 (364 leap year)
@      \->dmy breaks apart DATE
@      dmy\-> builds DATE, opposite of \->dmy
@      \->hms breaks apart TIME
@      hms\-> builds TIME, opposite of \->hms
@       hms same as \->hms except with fractional part, used by: clock
@     TODAY date time display
@     timef custom menu
@     TSTR\-> TSTR taken apart

@       \>>\>>\>> moon phase \<<\<<\<<
@      MOON moon phase
@      SIDM moon sidreal period
@      SYNM moon syndotic period
@      moon syndotic offset

@       \>>\>>\>> julian date prgms \<<\<<\<<
@      AJUL all julian date formats
@      DT\->J DATE & TIME to JULIAN
@    JULIAN JULIAN date & time
@       JDY JULIAN date in days
@       JYR JULIAN date in years
@      J\->DT JULIAN date to DATE & TIME
@           oldest TICK julian = 578101 (15 oct 1592)
@     ticks HP48 & TICK julian difference
@     WinXP HP48 & WinXP julian difference
@    julian prgm to create the following variables
@         J julian date based on system flags
@        YR year
@        MO month
@        DY day
@         H hour
@         M minute
@         S second
@ ERROR: JULIAN = 60: HP48 = 28.02.1900, WinXP = 29.02.1900
@ the HP48 WinXP (flag 42) function works for JULIAN > 60
@ I do not know if this is an Hewlett Packard or Microsoft issue
@ I tend to side with HP over MicroCRAP

@       \>>\>>\>> time flag control \<<\<<\<<
@      FLAG set various time flags
@            41 TICK julian
@            42 WinXP julian
@            43 ASTRO julian
@           -40 clock display
@           -41 12/24
@           -42 m/d/y / d.m.y
@           -57 alarm beep
@ I chose 42 because -42 is the date format flag
@  41: 1 = TICK        0 = HP48       precedence over flg 42
@  42: 1 = WinXP       0 = HP48
@ -42: 1 = dd.mm.yyyy, 0 = mm/dd/yyyy
//
/Var \->dmy
@ breaks apart DATE
\<<
   RCLF
   \-> f
   \<<
      -55 CF                           @ turn on LAST ARG
      IP
      LASTARG FP 100 * IP
      LASTARG FP 10000 *
      3 ROLLD
      IF
         -42 FC?                       @ flip day & month if needed
      THEN
         SWAP
      END
      ROT
      f STOF
   \>>
\>>
//
/Var \->hms
@ breaks apart TIME
\<<
   RCLF
   \-> f
   \<<
      -55 CF                           @ turn on LAST ARG
      IP
      LASTARG FP 100 * IP
      LASTARG FP 100 *
      f STOF
   \>>
\>>
//
/Var age
@ used: AGE
27.101956
//
/Var AGE
@ my age
@ uses: age
\<<
   RCLF
   \-> f
   \<<
      -42 SF
      age DATE DDAYS
      '1_d' \->UNIT
      '1_yr' CONVERT
      2 RND
      "AGE" \->TAG
      f STOF
   \>>
\>>
//
/Var AJUL
@ all julian date formats
\<<
   DATE TIME RCLF
   \-> d t f
   \<<
      CLUFL
      d t 43 SF DT\->J 43 CF
      d t 41 SF DT\->J 41 CF
      d t DT\->J
      d t 42 SF DT\->J
      f STOF
   \>>
\>>
//
/Var astro
@ offset to UT
2299160.7625
//
/Var CALEN
@ graphical calendar starting week before current date
\<<
   RCLF \-> f
   \<<
      STD
      # 83h # 40h PDIM
      { # 0h # 0h } PVIEW
      -42 SF
      DATE
      DUP DOW 1 - NEG DATE+ -7 DATE+   @ calc start date
      " M  T  W  R  F  S  N  "         @ header
      2 1 1 3 SF GDISP
      0 6
      FOR R                            @ row
         0 6
         FOR C                         @ column
            DUP C R 7 * + DATE+
            IF
               DUP DATE ==
            THEN
               3 SF
            END
            IP 2 PAD0                  @ display day
            2 R 2 + C 3 * 1 + .5 + GDISP
         NEXT
      NEXT
      DROP
      f STOF
      { } PVIEW
   \>>
\>>
//
/Var clock
@ bar clock
@ used by: CLOCK
@ uses: hms
\<<
   DATE TIME "\127"
   \-> t c
   \<<
      t TSTR t hms
      \-> h m s
      \<<
         c h 24 / 22 * RPT
         c m 60 / 22 * RPT
         c s 60 / 22 * RPT
      \>>
      6 3
      FOR n
         n DISP
      -1 STEP
   \>>
\>>
//
/Var CLOCK
@ bar clock
@ uses: clock
\<<
   CLLCD "----------------------"
   \-> c
   \<<
      "Bar Clock" 15 RJST 1 DISP       @ prepare display area
      c 2 DISP
      c 7 DISP
    DO clock                           @ run clock
    UNTIL
      KEY
    END
    DROP
  \>>
\>>

//
/Var date
@ tagged date
\<<
   DATE "DTE" \->TAG
\>>
//
/Var dow
@ date to dow (1=M)
\<<
   IF -42 FS?
   THEN
      15.101582
   ELSE
      10.151582
   END
   SWAP DDAYS 4 + 7 MOD 1 +
   { "M" "T" "W" "R" "F" "S" "N" }
   OVER GET \->TAG
   "DOW" \->TAG
\>>
//
/Var DOY\->
@ doy to date
\<<
   1 - DATE 100 * FP 100 / 1.01 +
   SWAP DATE+
   "DTE" \->TAG
\>>
//
/Var DOY\<-
@ date to doy
\<<
   DATE 100 * FP 100 / 1.01 +
   SWAP DDAYS 1 +
   "DOY" \->TAG
\>>
//
/Var DST
@ dst clock
\<<
   "  \|v The Real Time \|v" 3 DISP
   " \[] " 7 RPT 5 DISP
   "  \|^  DST CRAP!!!  \|^" 7 DISP
   DO
      DATE TIME
      \-> d t
      \<<
         d t TSTR 4 DISP
         d t 1 + TSTR 6 DISP
      \>>
   UNTIL KEY
   END
   DROP
\>>
//
/Var DT\->J
@ date & time to julian
@ tags julian with format
\<<
   SWAP
   IF
      -42 FS?                          @ date format
   THEN
      15.101582
   ELSE
      10.151582
   END
      SWAP DDAYS SWAP HMS\-> 24 / +
   CASE
      41 FS?
      THEN
         ticks + "TICK"
      END
      42 FS?
      THEN
         WinXP - "WinXP"
      END
      43 FS?
      THEN
         astro + "ASTRO"
      END
      "HP48"
   END
   \->TAG
\>>

//
/Var DY
5

//
/Var H
14
//
/Var hms
@ breaks apart TIME leaving fractional part
@ used by: clock
\<<
   HMS\-> DUP FP 60 * DUP FP 60 *
\>>
//
/Var hms\->
@ build time
@ opposite of \->hms
@ similar to dmy\->; can not use '\->' with \->hms, reserved var
\<<
   100 / SWAP IP + 100 / SWAP IP +
\>>
//
/Var J
158018.596321
//
/Var J\->DT
@ JULIAN date to DATE & TIME
@ if tagged, uses tag for julian format
@ oldest TICK julian = 578101 (15 oct 1592)
\<<
   RCLF
   \-> f
   \<<
      IF
         DUP TYPE 12 ==                @ use tag for julian format else flg
      THEN
         CLUFL
         OBJ\->
         \-> t
         \<<
            CASE
               t "TICK" ==
               THEN
                  41 SF
               END
               t "WinXP" ==
               THEN
                  42 SF
               END
               t "ASTRO" ==
               THEN
                  43 SF
               END
            END
         \>>
      END
      CASE
         41 FS?
         THEN
            ticks -
         END
         42 FS?
         THEN
            WinXP +
         END
         43 FS?
         THEN
            astro -
         END
      END
      FP LASTARG IP
      IF
         -42 FS?                       @ date format
      THEN
         15.101582
      ELSE
         10.151582
      END
      SWAP DATE+ SWAP 24 * 4 RND \->HMS f STOF
   \>>
\>>
//
/Var JDY
@ JULIAN date in days
\<<
   JULIAN '1_d' \->UNIT
\>>
//
/Var JULIAN
@ current julian date based on flg settings
\<<
   DATE TIME DT\->J
\>>
//
/Var JYR
@ JULIAN date in years
\<<
   JDY '1_yr' CONVERT
\>>
//
/Var M
18
//
/Var MOON
@ moon phase
\<<
   RCLF
   \-> f
   \<<
      DEG
      STD
      CLUFL
      JULIAN moon + SYNM MOD SYNM / 360 *
      \-> \Gh
      \<<
         \Gh COS 1 + 2 / 100 * 1 RND \Gh SIN NEG 2 RND SIGN
         \-> p s
         \<<
            p "MOON%"
            CASE
               s 1 ==
               THEN
                  "WAX"
               END
               s -1 ==
               THEN
                  "WAN"
               END
               CASE
                  p 100 ==
                  THEN
                     "FULL"
                  END
                  "NEW"
               END
            END
            + \->TAG
         \>>
      \>>
      f STOF
   \>>
\>>
//
/Var moon
@ syndotic offset
3.1
//
/Var S
42.076782
//
/Var SIDM
@ moon sidreal period
27.32166
//
/Var SYNM
@ SYNM moon syndotic period
29.53059
//
/Var ticks
@ difference in HP48 julian & TICK julian
578101
//
/Var timef
@
{
   MAIN
   {
      "TMNU"
      {
         \<<
            94 MENU
         \>>
      }
   }
   date dow DOY\<- DOY\->
   AGE JULIAN tstr clkadj UTIL
}
//
/Var tstr
@ time string
\<<
   DATE TIME TSTR
\>>
//
/Var WinXP
@ difference in HP48 julian & WinXP julian
115858
//
/Var YR
2015
