// HP 48 Program Development Link Application
//
/Angle Degrees
/FractionMark .
/InstallDir
/AutoExec
//
/Var \->\->NOTES
@ the latest in triangle solutions
@ I reduced the calculations to several subroutines

@ > > > triangle solutions
@ ASA
@ SAA
@ SAS
@ SSA (could have made it ASS)
@ SSS

@ > > > display
@ disp   display all
@ dispt  display the triantle with centroid
@ pic    display the title screen
@ proc   process vars for display

@ > > > variables
@ a b c        sides
@ \Ga \Gg \Gb      angles
@ A P C        area, permiter, & centroid
@ h v          height & vertex
@ p\Ga p\Gg p\Gb   points

@ > > > functions
@ abc\->\Gg ab\Gg\->c a\Gab\->\Gb a\Ga\Gb\->b \Ga\Gb\->\Gg   side & angle calculations
@ \->A \->C \->P \->h \->p \->v                    misc calculations

@ > > > misc
@ input           input form/screen
@ PPAR tri CST    system vars
//
/Var \->A
@ area
\<<
   \->h b h * 2 /
   \->NUM
   'A' STO
\>>
//
/Var \->C
@ centroid
\<<
   \->p
   p\Ga p\Gb + p\Gg + 3 /
   'C' STO
\>>
//
/Var \->h
@ height
\<<
   a \Gg SIN *
   \->NUM
   'h' STO
\>>
//
/Var \->p
@ points
@ be sure to calc v & h first
\<<
   RCLF
   \-> f
   \<<
      -19 CF SPHERE
      (0,0) 'p\Gg' STO
      b \->NUM 0 R\->C 'p\Ga' STO
      v h R\->C 'p\Gb' STO
      f STOF
   \>>
\>>
//
/Var \->P
@ perimeter
\<<
   a b + c +
   \->NUM
   'P' STO
\>>
//
/Var \->v
@ vertex from lower left
\<<
   a \Gg COS *
   \->NUM
   'v' STO
\>>
//
/Var \Ga\Gb\->\Gg
@ calc third angle
\<<
   + 180 SWAP -
   \->NUM
\>>
//
/Var a\Ga\Gb\->b
@ SAA calculation
\<<
   \-> a \Ga \Gb
   \<<
      a \Ga SIN / \Gb SIN *
      \->NUM
   \>>
\>>
//
/Var a\Gab\->\Gb
@ SAS calculation
\<<
   \-> a \Ga b
   \<<
      b \Ga SIN * a / ASIN
      \->NUM
   \>>
\>>
//
/Var ab\Gg\->c
@ SSA calculation
\<<
   \-> a b \Gg
   \<<
      a SQ b SQ + 2 a * b * \Gg COS * - \v/
      \->NUM
   \>>
\>>
//
/Var abc\->\Gg
@ SSS calculation
\<<
   \-> a b c
   \<<
      a SQ b SQ + c SQ - 2 a * b * / ACOS
      \->NUM
   \>>
\>>
//
/Var ASA
@ ASA
\<<
   "ASA" '\Ga' 'c' '\Gb' input
   \Ga \Gb \Ga\Gb\->\Gg     '\Gg' STO
   c \Gg \Ga a\Ga\Gb\->b  'a'   STO
   c \Gg \Gb a\Ga\Gb\->b  'b'   STO
   proc
   disp
\>>
//
/Var disp
@ display all
\<<
   { a b c \Ga \Gb \Gg A P v h C p\Ga p\Gb p\Gg }
   LDISP
   dispt
   pic
\>>
//
/Var dispt
@ display triangle
\<<
   CLLCD RCLF \-> f
   \<<
      -40 CF -55 CF
      p\Ga RE 130 / p\Gb IM 63 / MAX XPON  @ auto scale
      LASTARG MANT CEIL
      SWAP ALOG *
      \-> s
      \<<
         0 s 130 * XRNG 0 s 63 * YRNG
         s XPON 2 + ALOG ATICK
      \>>
      P.STD VIEW0 DRAX
      p\Ga p\Gb             LINE       @ triangle lines
      p\Gb p\Gg           LINE
      p\Gg p\Ga           LINE
      p\Ga p\Gb p\Gg + 2 /  LINE       @ centroid lines
      p\Gg p\Ga p\Gb + 2 /  LINE
      p\Gb p\Ga p\Gg + 2 /  LINE
      C DUP C\->R 3 HLINE 3 VLINE      @ centroid X & Y
      3 ENG 1 1 16 GDISP               @ disp centroid value
      "CENTROID" 1 2 26 GDISP
      f STOF
   \>>
   IF 21 FS?                           @ print ?
   THEN
      CR PRPICT
   ELSE
      0 WAIT DROP
   END
\>>
//
/Var pic
@ title screen
@ this is not necessary to operation of solutions
\<<
   RCLF
   \-> f
   \<<
      1.01 MENU
      P.STD
      -6.5 6.5 XRNG -3.1 3.2 YRNG
      VIEW3
   "Triangle    Solutions" DUP 3 1 1.5 GDISP
   3 1.1 1.6 2 SF GDISP                @ hiliting
    (0,2)   (4,-1) LINE
    (4,-1) (-4,-1) LINE
   (-4,-1)  (0,2)  LINE
    (0,2)   (0,-1) LINE
   (-4,2)   (0,2)  LINE
   DEG
   (0,0) # 2h MARK
   "\Ga"    2 6   19   GDISP
   "\Gb"    2 1.3 11.5 GDISP
   "\Gg"  2 6    3.7 GDISP
   "a"    2 3.4  7.2 GDISP
   "b"    2 6.8 11.2 GDISP
   "c"    2 3.4 15.7 GDISP
   "v"    2 2.6  5   GDISP
   "h"    2 3.8 12.3 GDISP
   "A"    2 5   14   GDISP
   "P"    2 4.4 20   GDISP
   "C"    2 4.6 10.5 GDISP
   "\|>EKT" 1 9.5 29.5 GDISP
   f STOF
   \>>
   IF 21 FS?
   THEN
      CR PRPICT
   END
\>>
//
/Var proc
@ process vars for display
\<<
   CLLCD RCLF
   \-> f
   \<<
      "Processing Vars" 4 DISP
      CLUFL CLUNT RECT
      \->v \->A \->P \->C
      { a b c \Ga \Gb \Gg A P v h C p\Ga p\Gb p\Gg }
      1
      \<<
         DUP VTYPE
         \-> v t
         \<<
            v RCL
            CASE
               t 0 ==
               THEN
                  9 RND
               END
               t 1 ==
               THEN
                  -5 RND
               END
            END
            v STO
         \>>
      \>>
      DOSUBS
      f STOF
      CLLCD
   \>>
\>>
//
/Var SAA
@ SAA
\<<
   "SAA" 'a' '\Ga' '\Gb' input
   \Ga \Gb \Ga\Gb\->\Gg     '\Gg' STO
   a \Ga \Gb a\Ga\Gb\->b    'b'   STO
   a \Ga \Gg a\Ga\Gb\->b  'c'   STO
   proc
   disp
\>>
//
/Var SAS
@ SAS
\<<
   "SAS" 'a' '\Gg' 'b' input
   a b \Gg ab\Gg\->c   'c' STO
   c \Gg a a\Gab\->\Gb     '\Ga' STO
   c \Gg b a\Gab\->\Gb     '\Gb' STO
   proc
   disp
\>>
//
/Var SSA
@ SSA
\<<
   "SSA" 'a' 'b' '\Ga' input
   a \Ga b a\Gab\->\Gb    '\Gb'   STO
   \Ga \Gb \Ga\Gb\->\Gg     '\Gg' STO
   a \Ga \Gg a\Ga\Gb\->b  'c'   STO
   proc
   disp
\>>
//
/Var SSS
@ SSS
\<<
   "SSS" 'a' 'b' 'c' input
   a b c abc\->\Gg  '\Gg' STO
   b c a abc\->\Gg  '\Ga'   STO
   a c b abc\->\Gg  '\Gb'   STO
   proc
   disp
\>>
