// HP 48 Program Development Link Application
//
/Angle Degrees
/FractionMark .
/InstallDir HOME
/AutoExec
//
/Var \->\->NOTES
@ General Purpose Utilities

@      \>>\>>\>> installed \<<\<<\<<
@     MAIN dir
@  AINFORM automatic INFORM
@   AINPUT automatic INPUT
@    AVAIL memory % available & version
@     BGPH text bargraph
@      C\->V complex to vector, ignore angle format
@      C\<-V vector to complex, ignore angle format
@   CLKMNU clock menu from TIMEF
@    CLUFL clear all user flags
@    CLUNT clear units from vars
@    DIRSC directory scan with various functions
@    EJECT eject printout
@     FRAC fraction display
@      GCD greatest common divisor
@    GDISP graphic display, simplified verson of the SX/GX
@   GLDISP LDISP on the graphics screen
@    HLINE horizontal line at Y with N spacing
@     IPFP IP & FP
@     KEYS send key assignments to another HP48
@    LDISP display list
@     MARK mark at (X,Y)
@      O\->S object to string
@      O\<-S string to object
@    P.PRN graphics sizes: printer
@    P.SPL                 printer & square
@    P.SQR                 square
@    P.STD                 standard
@     PAD0 left zero pad
@    PICTX get max binary graphics values
@   PRPICT print picture/graphics screen
@     REDC reduce fraction
@      REN rename a variable
@     RJST simple right justify
@    RJST2 right justify with options
@      RPT repeat a chr
@     SRTD sort directory, PRGM first
@     SYNC synchronize HP48 directories on server
@     UTIL run utility prgm using CHOOSE
@      VER version information w/system name
@     VIEW view locked graphics
@    VIEW0 view unlocked graphics
@    VIEW3 view unlocked graphics w/3 freeze
@    VIEW7 view unlocked graphics w/7 freeze
@    VLINE vertical line at X with N spacing
@   clkadj clock adjustment menu
@    dirsc recursive part
@  dirsc.0 default directory display
@  dirsc.1 find var
@       .2 sord dir (no sub)
@  dirsc.3 send BKP vars
@  dirsc.4 send all
@  dirsc.5 find str in var type
@  dirsc.6 pring var type, checksum, & bytes (not implemented on HP48)
@   inform used by AINFORM, sto INFORM data
@      mod 1 based MOD
@      rcl recall var & tag
@     srtd used by: SRTD
@      sto store var using its' tag
@     str\-> comma formatted mumeric string to number
@     str\<- number to comma formatted string
@     type type string

@     home custom menu
@    IOPAR io parameters

@      \>>\>>\>> not used \<<\<<\<<
@    BEEP3 3 beeps of 3 beeps
@      BKP searches for 'bkp' var, now part of DIRSC
@   CHCASE change case using flags
@     CONV convert various default units
@      DEL delete item from list
@    DIRSC
@      KEY wait until key pressed
@     EVEN tests if even
@   EXTIME given 'prgm' find execution time in seconds
@    FINDV find 'var', now part of DIRSC
@   FLAG~O first 6 user flags menu
@   INVSTK invert stack
@     IPFP integer & fraction parts
@   LGDISP  graphic list display
@    LOWER lower case
@     MNU\-> protected menu to standard
@     MNU\<- standard menu to protected
@     NOTE play a note
@      ODD tests if odd
@    PARSE parse string at returns
@     PLAY play a list of notes
@     PULL recall & delete list of variables
@   ROWCOL # & col to 1 based row & col
@     SRTA recursive sort all directories
@   TGCASE toggle case
@    UPPER upper case
@      VER system version
@ archive~ backup to IO w/date name
@  archive simple backup to IO
@     beep system error beep emulator
@    bytes bytes by var type
@    findv used by FINDV
@   flag~o used by: FLAG
@     flag used by FLAG in individual directories
@ flgstr~o used by: FLAG
@ flgmnu~o used by: FLAG
@   flgstr used by flag
@     head get list before position
@     play play a song
@      pos POS with start #
@     srta used by: SRTA
@     tail get list after position
//
/Var AINFORM
@ automatic INFORM
@ given: title, # columns, &  variable list
@ uses: inform, type
@ l1: { var help type }
@ l2: { reset values }
\<<
   CLLCD { } { }
   \-> l1 l2
   \<<
      1
      \<<
         GETI
         \-> o
         \<<
            l2
            o RCL TYPE                 @ object type
            \-> t
            \<<
               o RCL                   @ object
               t type
               o O\->S SWAP 2 \->LIST  @ removed type casting
@               o O\->S SWAP t 3 \->LIST @ type casting issue
               1 \->LIST l1 SWAP + 'l1' STO
               + 'l2' STO
            \>>
         \>>
      \>>
      DOSUBS
      l1                               @ variable list
      SWAP 0 2 \->LIST                 @ # col & tab
      l2 DUP                           @ reset values list
      IF
         INFORM
      THEN
         l1 inform                     @ if entered process data
      END
   \>>
\>>
//
/Var AINPUT
@ automatic INPUT
@ given: title &  variable list (l)
@ s: variable string
@ M: saved menu
\<<
   CLLCD
   ""
   RCLMENU
   \-> l s m
   \<<
      l
      1
      \<<                              @ build variable string
         GETI DUP RCL SWAP \->TAG
         IF
            -64 FC?
         THEN
            10 CHR +
         END
         s SWAP + 's' STO
      \>>
      DOSUBS
      s -1 s " " POS 1 + 2 \->LIST     @ position list
                                       @ optional control char
      'V' +                            @ change INPUT list #
      2 \->LIST                        @ INPUT list
      28 MENU                          @ edit menu
      INPUT
      CLLCD
      OBJ\->                           @ get variables from string
      1 l SIZE
      START
         sto                           @ sto data
      NEXT
      m MENU                           @ restore menu

  \>>
\>>
//
/Var archive
@ simple backup to IO
\<<
   PATH                                @ sae curr dir
   HOME                                @ go HOME
   RCLF 'flags' STO                    @ save flags
   :IO: ARCH ARCHIVE FINISH CLOSEIO    @ backup
   'flags' PURGE                       @ clear flags var
   EVAL                                @ back to curr dir
\>>
//
/Var archive~
@ backup to IO w/date file name
\<<
   PATH                                @ save curr dir
   HOME                                @ go HOME
   RCLF 'flags' STO                    @ save flags
   STD 55 CF                           @ set flags
   DATE                                @ get date & separate d, m, & y
   IP LASTARG FP 100 * IP LASTARG FP 10000 *
   \-> d m y
   \<<                                 @ build archive name
      "B" y \->STR +
      IF
         m 10 <
      THEN
         "0"
      ELSE
         ""
      END

         m \->STR + +
      IF
         d 10 <
      THEN
         "0"
      ELSE
         ""
      END
      d \->STR + +
      OBJ\->
      "IO" \->TAG
   \>>
   ARCHIVE                             @ perform backup to IO
   flags STOF                          @ restore flage
   'flags' PURGE                       @ clear flags variable
   EVAL                                @ back to curr dir
\>>
//
/Var AVAIL
@ memory % available & version
\<<
   CLLCD 22 RCLF
   \-> n f
   \<<
      VERSION                          @ version strings
      MEM 32768 /                      @ mem %
      DUP n * 0 RND                    @ bar graph size
      \-> p i
      \<<
         "Mem Avail: "                 @ mem % string
         p 100 * 1 FIX \->STR "%" + +
         i BGPH                        @ bar graph
         "-" n i - RPT +               @ pad empty space
         6 DISP 5 DISP 4 DISP 3 DISP
         2 FREEZE
         f STOF
      \>>
   \>>
\>>
//
/Var B\->C
@ binary to character
\<<
   B\->R CHR
\>>
//
/Var B\->G
@ binary to gray code
\<<
   DUP SR XOR
\>>
//
/Var B\->S
@ binary to string
\<<
   RCLF
   \-> b n f
   \<<
      2 n 1 - ^ R\->B
      \-> q
      \<<
         "" 1 n
         START
            IF b q AND B\->R
            THEN
               "\127"
            ELSE
               "-"
            END
            + b SL 'b' STO
         NEXT
      \>>
      f STOF
   \>>
\>>
//
/Var B\<-C
@ character to binary
\<<
   NUM R\->B
\>>
//
/Var B\<-G
@ gray code to binary
\<<
   DUP SR
   \-> m
   \<<
      DO
         m XOR m SR 'm' STO
      UNTIL m # 0h ==
      END
   \>>
\>>
//
/Var beep
@ system error beep
@ there is also a SYSEVAL...?
\<<
   1400 .08 BEEP
\>>
//
/Var BEEP3
@ 3 beeps of 3 beeps
@ given: note step
\<<
   12 / 2 SWAP ^ 440 *
   .05
   \-> f d
   \<<
      1 3
      START
         1 3
         START
            f d BEEP d WAIT
         NEXT
         d 4 * WAIT
      NEXT
   \>>
\>>
//
/Var BGPH
@ bar graph
@ uses: RPT
\<<
   0 RND "\127" SWAP RPT
\>>
//
/Var bytes
@ prgm bytes list with path in var 'tmp'
\<<
   CLLCD
   "Working" 1 DISP
   PATH
   8 TVARS 1                           @ prgm list
   DO                                  @ get bytes for prgms
      \-> i
      \<<
         i GETI                        @ get prgm
         DUP                           @ save for later display
         BYTES 3 \->LIST               @ make bytes list
         DUP i 1 - 7 MOD 1 + DISP      @ display
         3 ROLLD                       @ move to top of working list
      \>>
   UNTIL
      -64 FS?
   END
   DROP
   SIZE 1 + \->LIST                    @ make list of all prgms with path
   'tmp' STO                           @ save list
\>>
//
/Var C\->V
\<<
   \-> V
   \<< V
       IF V TYPE 1 ==
       THEN
          C\->R 2 \->ARRY
       ELSE
          # 202h DOERR
       END
   \>>
\>>
//
/Var C\<-V
\<<
   \-> V
   \<<
      V
      IF V TYPE 3 ==
      THEN
         IF V SIZE { 2 } ==
         THEN
            OBJ\-> DROP R\->C
         ELSE
            # 501h DOERR
         END
      ELSE
         # 202h DOERR
      END
   \>>
\>>
//
/Var CHCASE
@ change case
@ flag: none   UPCASE
@        1     LWCASE
@        2     TGCASE
@        3     title case, a bit slower because of the testing
\<<
   CLLCD DUP SIZE RCLF
   \-> n f
   \<<
      n 2 DISP 64 SF
      1 n
      FOR i
         i 1 DISP DUP i DUP SUB
         CASE
            1 FS?                      @ lower case
            THEN
               LWCASE
            END
            2 FS?                      @ toggle case
            THEN
               TGCASE
            END
            3 FS?                      @ title case
            THEN
               IF
                  64 FS?C
               THEN
                  UPCASE
               ELSE
                  LWCASE
               END
                IF
                  DUP " " == OVER " " == OR
               THEN
                  64 SF
               END
            END
            UPCASE                     @ dflt upper case
         END
         i SWAP REPL
      NEXT
      f STOF
   \>>
\>>
//
/Var CLKMNU
@ munu clock
@ press text to update clock
@ press "\127\127\127\127\127" to turn off
\<<
   -40 CF -62 SF DATE TIME TSTR "\127\127\127\127\127"
   \<<
      CLKMNU
   \>>
   \<<
      OFF CLKMNU
   \>>
   \-> s c p q
   \<<
      s 1 3 SUB p 2 \->LIST
      s 5 9 SUB p 2 \->LIST
      DATE 100 * FP 10000 * \->STR p 2 \->LIST
      c q 2 \->LIST
      IF -41 FC?
      THEN
         s 14 18 SUB p 2 \->LIST
         s 22 DUP SUB p 2 \->LIST
      ELSE
         s 15 19 SUB p 2 \->LIST
         c q 2 \->LIST
      END
   \>>
   6 \->LIST TMENU
\>>
//
/Var CLUFL
@ clear user flags
@ WARNING! flags 60 & 61 are used by the EQ LIB
\<<
   RCLF
   2 # 0h PUT
   STOF
\>>
//
/Var CLUNT
@ clears units from variables
\<<
   13 TVARS
   IF DUP SIZE 0 \=/
   THEN
      1
      \<<
         NSUB
         \-> V N
         \<<
            V RCL UVAL V STO
         \>>
       \>>
       DOSUBS
       1 WAIT
   ELSE
      DROP
   END
\>>
//
/Var CONV
@ auto comvert for mm-in, C-F, kg-lb
\<<
   EVAL 7 CF
   \-> n
   \<<
      IF
         n TYPE 13 ==
      THEN
         n OBJ\-> \->STR DUP SIZE 1 - 4 SWAP SUB
         \-> u
         \<<
            DROP n
            CASE
               u "in" ==               @ length
               THEN
                  '1_mm'
               END
               u "mm" ==
               THEN
                  '1_in'
               END
               u "lb" ==               @ weight
               THEN
                  '1_kg'
               END
               u "kg" ==
               THEN
                  '1_lb'
               END
               u "\^oF" ==             @ temperature
               THEN
                  '1_\^oC'
               END
               u "\^oC" ==
               THEN
                  '1_\^oF'
               END
               7 SF                    @ known unit
            END
            IF
               7 FS?C                  @ unit error?
            THEN
               5 BGPH "Unknown Unit" OVER + + 3 DISP 2 FREEZE beep
            ELSE
               CONVERT 9 RND
            END
         \>>
      ELSE
         n
      END
   \>>
\>>
//
/Var CST
'home'
//
/Var DEL
@ delete item in list
\<<
   OVER SWAP POS OVER SIZE
   \-> l p s
   \<<
      IF p
      THEN
         CASE
            p 1 ==
            THEN
               l p tail
            END
            p s ==
            THEN
               l p head
            END
            l p head
            l p tail +
         END
      ELSE
         l
      END
   \>>
\>>
//
/Var dirsc
@ the recursive part of DIRSC
@ uses: broke out CASE subroutines into separate prgms
\<<
   "\|>" PATH DUP SIZE GET + RCLF
   \-> \<-p f
   \<<
      CASE
         0 \<-q ==                     @ scan w/depth
         THEN
            dirsc.0
         END
         1 \<-q ==                     @ find var
         THEN
            dirsc.1
         END
         2 \<-q ==                     @ sord dir
         THEN
            SRTD
         END
         3 \<-q ==                     @ send BKP
         THEN
            dirsc.3
         END
         4 \<-q ==                     @ send all
         THEN
            dirsc.4
         END
         5 \<-q ==                     @ find str
         THEN
            dirsc.5                    @ scan no depth
         END
         "Scan No Fx" 1 DISP           @ no Fx
         \<-p 2 DISP
         1 WAIT
      END
      15 TVARS                         @ get directories
      IF DUP SIZE 0 ==
      THEN
         DROP
      ELSE
         1                             @ DOSUBS causes PATH left
         DO                            @ on stack to be enLISTed
            GETI
            EVAL
            dirsc                      @ > > > recurse < < <
         UNTIL
            -64 FS?
         END
         DROP2
      END
      CASE                             @ end recursion cleanup
         0 \<-q ==                     @ scan w/depth display
         THEN
            ""
            PATH SIZE 1 +
            DISP
            UPDIR
         END
      END
      IF 64 FS?                        @ preserve flag 64 through recurrsion
      THEN
         f 2
         RCLF 2 GET
         PUT
         'f' STO
      END
      f STOF
   \>>
\>>
//
/Var DIRSC
@ directory scan
@ this sets up the environment for dirsc
@ uses: dirsc, SYNC, VER
@ 0 or empty stack scan with depth
@ 1 find variable name
@ 2 sort all directories
@ 3 send BKP variables & erase
@ 4 send all variables
@ 5 search for string in variable type, can take some time
@ 6 print variable type name, chksm, & bytes ( not implemented on the 48G)
@ 6+ scan with no depth
@
@ flag 5 no HOME
@
\<<
   64 CF                               @ clear user end flag
   IF DEPTH 0 ==                       @ default for empty stack
   THEN
      0
   END
   ""                                  @ blank var
   \-> \<-q \<-v                       @ global local variables
   \<<
      CLLCD
      PATH                             @ leave path on stack
      IF 5 FC?C                        @ reset to HOME ?
      THEN
         HOME
      END
      CASE
         0 \<-q ==                     @ scan w/depth
         THEN
            IF 21 FS?                  @ print ?
            THEN
               VER
            END
         END
         1 \<-q == 5 \<-q == OR        @ find var / str
         THEN
            SWAP '\<-v' STO            @ store var
         END
      END
      dirsc                            @ > > > start scan < < <
      EVAL                             @ eval path on stack
      CASE
         1 \<-q == 5 \<-q == OR        @ find var / str
         THEN
            IF 64 FC?                  @ not found ?
            THEN
               CLLCD
               "Not Found" 4 DISP
               2 FREEZE
            END
         END
         3 \<-q == 4 \<-q == OR        @ send BKP or all
         THEN
            SYNC FINISH
         END
      END
   \>>
\>>
//
/Var dirsc.1
@ dirsc: find var
\<<
   "Find Var: " \<-v + 1 DISP
   \<-p 2 DISP
   IF VARS \<-v POS                    @ save path to top of stack
   THEN
      PATH DEPTH ROLLD
      64 SF
   END
\>>
//
/Var dirsc.3
@ dirsc: send BKP
\<<
   "Send BKP" 4 DISP
   \<-p 5 DISP
   IF VARS 'BKP' POS
   THEN
      SYNC
      BKP SEND
      'BKP' PURGE
      CLLCD
   END
\>>
//
/Var dirsc.4
@ dirsc: send all
\<<
   "Send All Vars" 4 DISP
   \<-p 5 DISP
   SYNC
   0 13 FOR t
      t TVARS SEND
   NEXT
   CLLCD
\>>
//
/Var dirsc.5
@ dirsc: find str
\<<
   \<-v OBJ \-> DROP
   \-> s t
   \<<
      "Find Str: " s + 1 DISP
      \<-p 2 DISP
      "" 3 DISP
      t TVARS
      IF DUP SIZE 0 ==
      THEN
         DROP
      ELSE
         1
         \<<
            \-> v
            \<<
               v
               DUP 3 DISP
               RCL \->STR
               IF s POS
               THEN
                  v PATH 2 \->LIST DEPTH ROLLD 64 SF
               END
            \>>
         \>>
         DOSUBS                        @ OK in sub like this
      END
   \>>
\>>
//
/Var DOKEY
@ wait until key pressed
@ flag 6: graphic display
@ flag 7: return key-press
\<<
   "\>>>PRESS ANY KEY\<<<"
   IF
      6 FC?C
   THEN
      "  " SWAP + 7 DISP
   ELSE
      1 10.8 8 GDISP
      { # 0h # 0h } PVIEW
   END
   0 WAIT
   IF
      7 FC?C
   THEN
      DROP
   END
\>>
//
/Var EJECT
@ eject printout
\<<
   1 6
   START
      CR
   NEXT
\>>
//
/Var EVEN
@ tests if even
\<<
   2 / FP 0 ==
\>>
//
/Var EXTIME
@ given 'prgm' find execution time in seconds
\<<
   TICKS
   \-> t
   \<<
      EVAL                             @ run prgm
      TICKS t -                        @ delta ticks
      B\->R 8192 /                     @ convert to seconds
      .0106 - 4 RND                    @ appx adj EXTIME delay & RND
      '1_s' \->UNIT                    @ make unit
   \>>
\>>
//
/Var findv
@ recursive search for a var
@ uses persistent flag 64 to indicate found status
@ NOW PART OF dirsc #1
\<<
   RCLF
   \-> s f                             @ save search & flags
   \<<
      IF
         VARS s POS                    @ find var
      THEN
         64 SF                         @ set found flag
         PATH DEPTH ROLLD              @ save path
      END
      15 TVARS                         @ directories
      IF
         DUP SIZE 0 >                  @ no more directories ?
      THEN
         1
         \<<
            \-> l
            \<<
               l 1 DISP                @ show directory
               l EVAL                  @ goto directory
               s findv                 @ find var \<<\<<\<< recurse \>>\>>\>>
            \>>
         \>>
         DOSUBS
         UPDIR                         @ backup
         64 FS?                        @ save found flag to stack
         f STOF                        @ restore flags
         IF                            @ set found flag
         THEN
            64 SF
         END
      ELSE
         DROP                          @ clear no directories list
      END
   \>>
\>>
//
/Var FINDV
@ find var
@ uses: findv
\<<
   CLLCD
   64 CF
   PATH SWAP                           @ save starting path
   HOME "HOME" 1 DISP                  @ goto HOME
   findv EVAL                          @ start recrusive search
   IF
      64 FC?C                          @ not found message
   THEN
      "Not Found" 3 DISP 2 FREEZE
   END
\>>
//
/Var flag
@ flag menu
@ used by: FLAG (in individual directories)
\<<
   \-> n p
   \<<
      'flgmnu' p                       @ leave on stack for later PUT
      'flgmnu' p GET 1 GET             @ get flag string
      \-> s
      \<<
         IF
            n FC?C                     @ toggle flag
         THEN
            n SF s                     @ leave string on stack
         ELSE
            s 1 s "\[]" POS 1 - SUB    @ strip chr from str & leave on stack
         END
      \>>
      n p flgstr                       @ rebuild flag string
      PUT                              @ insert new flag string in menu
      flgmnu TMENU
   \>>
\>>
//
/Var flag~o
@ sub for FLAG
@ used by TMENU to change flag annunciator
@ uses: flgstr, flag, tmenu
\<<
   PATH
   \-> n p
   \<<
      IF
         n FC?C
      THEN
         n SF
      END
      'flgmnu' n DUP flgstr~o PUT
      flgmnu~o TMENU
      p EVAL
   \>>
\>>
//
/Var FLAG~O
@ set / clear first six user flags
@ a single menu full of flags & indicators
@ first five user flags have annunciators
@ uses: flgstr, flag, tmenu
\<<
   6 PATH
   \-> m p
   \<<
      1 m                              @ build initial flag strings
      FOR n
         n flgstr~o
      NEXT
      m \->LIST 'flgmnu~o' STO flgmnu~o TMENU
      p EVAL
   \>>
\>>
//
/Var flgmnu~o
@ used by: FLAG
{
   { "1" \<< 1 flag \>> }
   { "2" \<< 2 flag \>> }
   { "3" \<< 3 flag \>> }
   { "4" \<< 4 flag \>> }
   { "5" \<< 5 flag \>> }
   { "6" \<< 6 flag \>> }
}
//
/Var flgstr
@ used by: FLAG (in individual directories) & flag
@ VARS
@ s flag string, 3 char optimum
@ n flag #
@ p position in menu list
@ f saved flags for this prgm
\<<
   RCLF
   \-> s n p f
   \<<
      STD
      s
      IF
         n FS?                         @ flag indicator
      THEN
         "\[]" +
      END
      "\<< " n \->STR + " " + p + " flag" + " \>>" +  @ build command
      OBJ\-> 2 \->LIST                 @ create menu list
      f STOF
   \>>
\>>
//
/Var flgstr~o
@ sub for FLAG
@ builds flag string
\<<
   RCLF
   \-> n f
   \<<
      STD n \->STR
      IF
         n FS?
      THEN
         "\[]" +
      END
      "\<< " n \->STR + " flag~o" + " \>>" + OBJ\-> 2 \->LIST
      f STOF
   \>>
\>>
//
/Var FRAC
@ fraction
@ uses: various flags for precision control
@ I charted the fractional precision changes and developed a formula
@   1 2 3
@ 0         low precision
@ 1 X
@ 2   X
@ 3 X X
@ 4     X
@ 5 X   X   max precision
\<<
   EVAL UVAL RCLF
   \-> n f
   \<<
      f 2 GET # 7d AND B\->R
      \-> i
      \<<
         IF
            i 5 >
         THEN
            5 'i' STO
         END
         i 2.2 * 1.3333 + FIX
         n \->Q REDC
         DUP EVAL n - 3 ENG \->TAG
         f STOF
      \>>
   \>>
\>>
//
/Var GCD
@ greatest common divisor
@ for reducing fractions
@ from '1 Minute Marvels'
@ did a VBA for EXCEL
\<<
   WHILE
      OVER MOD DUP
   REPEAT
      SWAP
   END
   DROP
\>>
//
/Var GDISP
@ graphic display
\<<
   1 - SWAP 1 -
   \-> v n c r
   \<<
      PICT
      CASE                             @ character size
         n 1 ==
         THEN
            r 6 * c 4 *
         END
         n 2 ==
         THEN
            r 8 * c 6 *
         END
         n 0 == n 3 == OR              @ EQ is sz 3, has its' own rules
         THEN
            r 10 * c 6 *
         END
      END
      R\->B SWAP R\->B 2 \->LIST v n \->GROB
      IF                               @ invert character
         1 FS?C
      THEN
            NEG
      END
      CASE                             @ graphic combine type
         2 FS?C
         THEN
            GOR
         END
         3 FS?C
         THEN
            GXOR
         END
         REPL
      END
   \>>
\>>
//
/Var GLDISP
@ graphics versio of LDISP
\<<
   CLLCD OVER SIZE RCLF
   \-> s z f
   \<<
      CASE
         1 s ==
         THEN
            10
         END
         2 s ==
         THEN
            8
         END
         3 s ==
         THEN
            6
         END
      END
      \-> q
      \<<
         -40 CF P.STD VIEW7 1
         \<<
            \-> v
            \<<
               v
               IF v TYPE 6 ==
               THEN
                  IF v VTYPE 0 \>= v VTYPE 2 \<= AND
                  THEN
                     RCL v \->TAG
                  END
               END
               NSUB q mod
               \-> n
               \<<
                  s n 1 GDISP
                  IF n q == NSUB z == OR
                  THEN
                     IF 21 FS?
                     THEN
                        PRPICT
                     ELSE
                        0 WAIT DROP
                     END
                     ERASE
                  END
               \>>
            \>>
         \>>
         DOSUBS
      \>>
      f STOF
   \>>
\>>
//
/Var head
@ get list before position
\<<
   1 SWAP 1 - SUB
\>>
//
/Var HLINE
@ draw horizontal line at y with spacing
@ uses: PICTX
\<<
   SWAP                                @ swap spacing
   0 SWAP R\->C C\->PX 2 GET           @ get binary y
   \-> S M
   \<<
      IF S 1 \<=
      THEN
         # 0h M 2 \->LIST PICTX 1 GET M 2 \->LIST LINE
      ELSE
         0 PICTX 1 GET B\->R
         FOR N
            N R\->B M 2 \->LIST PIXON
         S STEP
      END
   \>>
\>>
//
/Var home
@ home menu
@ used by UTIL
{
   MAIN AVAIL CL     KMNU DIRSC FRAC
   REN  SRTD  clkadj rcl  sto
}
//
/Var inform
@ process INFORM data
@ given: INFORM return data (i) & INFORM variable list (l)
@ used by AINFORM
@ o: offset
\<<
   CLLCD
   SWAP 0
   \-> l o
   \<<
      1
      \<<
         \-> i
         \<<
            i GETI
            \-> t
            \<<
               IF
                  t TYPE 5 ==
               THEN
                  IF
                     t SIZE 0 ==
                  THEN
                     'o' 1 STO-
                  ELSE
                     l i o + GET t 1 GET \->TAG sto
                  END
               ELSE
                  l i o + GET t \->TAG sto
               END
            \>>
         \>>
      \>>
      DOSUBS
   \>>
\>>
//
/Var INVSTK
@ invert the stack, any depth
\<<
   IF
      DEPTH DUP 1 >                    @ min 2 objects on stack
   THEN
      2 SWAP
      FOR n
         n ROLL
      NEXT
   ELSE
      DROP
   END
\>>
//
/Var IOPAR
@ i/o parameters
{ 9600 0 0 0 3 3 }
//
/Var IPFP
@ integer & fraction parts
\<<
   IP LASTARG FP
\>>
//
/Var KEYS
@ send key assignments
\<<
   RCLKEYS \->STR
   " STOKEYS" +
   "C" PKT DROP
\>>
//
/Var LDISP
@ list diaplay
@ wraps screen with stop
\<<
   CLLCD DUP SIZE RCLF
   \-> z f
   \<< -40 CF 1
      \<<
         \-> v
         \<< v
            IF v TYPE 6 ==
            THEN
               IF v VTYPE 0 \>=
               THEN
                  RCL v \->TAG
               END
            END
            NSUB 7 mod \-> n
            \<<
               IF 21 FS?
               THEN
                  PR1
               END
               n DISP
               IF 21 FC?
               THEN
                  IF n 7 == NSUB z == OR
                  THEN
                     0 WAIT DROP CLLCD
                  END
               END
            \>>
         \>>
      \>>
      DOSUBS
      f STOF
   \>>
\>>
//
/Var LGDISP
@ list graphics display
@ self sizes for # of items
\<<
   CLLCD DUP SIZE
   \-> s
   \<<
      # 83h # 40h s 1 - 10.5 / CEIL * PDIM  @ size display
      { # 0h # 0h } PVIEW              @ show graphics screen
      1
      DO                               @ process list
         \-> i
         \<<
            i GETI
            \-> v
            \<<
               v
               IF                      @ if var try to RCL
                  v TYPE 6 ==
               THEN
                  IF                   @ alt to IFERR RCL...
                     v VTYPE 0 \>=
                  THEN
                  RCL
                     rcl
                  END
               END
               1 i 1 GDISP             @ graphic display
            \>>
         \>>
      UNTIL -64 FS?
      END
      DROP2                            @ clear working list
      { } PVIEW                        @ stay on graphics screen
   \>>
\>>
//
/Var LJST
@ left justify
\<<
   \-> s n
   \<<
      s " " n s SIZE - RPT +
   \>>
\>>
//
/Var LOWER
@ convert to lower case
\<<
   \-> s
   \<<
      "" 1 s SIZE
      FOR p
         s p DUP SUB NUM
         \-> n
         \<<
            n
            IF
               n 65 \>= n 90 \<= AND
            THEN
               32 +
            END
            CHR +
         \>>
      NEXT
   \>>
\>>
//
/Var MARK
@ mark at (x,y)
\<<
   RCLF \-> R F
   \<<
      DEG
      IF DUP TYPE 0 ==
      THEN
         R\->C
      END
      IF DUP TYPE 1 ==
      THEN
         C\->PX
      END
      R 0 360 ARC
      F STOF
   \>>
\>>
//
/Var MNU\->
@ protected menu list to standard menu list
@ {
@     { "LOWER" { LOWER } }
@     { "MNU\->" { MNU\-> } }
@     { "MNU\<-" { MNU\<- } }
@     { "O\->S" { O\->S } }
@     { "sto" { sto } }
@     { "EJECT" { EJECT } }
@ }
@ to
@ { LOWER MNU\-> MNU\<- O\->S sto EJECT }
\<<
   \-> lst
   \<<
      IF
         lst TYPE 6 ==
      THEN
         lst RCL
      ELSE
         lst
      END
      \<<
         \-> itm1
         \<<
            IF
               itm1 TYPE 5 == itm1 SIZE 2 == AND
            THEN
               itm1 2 GET \-> itm2
               \<<
                  IF
                     itm2 TYPE 5 == itm2 SIZE 1 == AND
                  THEN
                     itm2 1 GET \-> itm3
                     \<<
                        IF
                           itm3 TYPE 6 ==
                        THEN
                           itm3
                        ELSE
                           itm1
                        END
                     \>>
                  ELSE
                     itm1
                  END
               \>>
            ELSE
               itm1
            END
         \>>
      \>>
      DOSUBS
      IF
         lst TYPE 6 ==
      THEN
         lst STO
      END
   \>>
\>>
//
/Var MNU\<-
@ standard menu list to protected menu list
@ { LOWER MNU\-> MNU\<- O\->S sto EJECT }
@ to
@ {
@     { "LOWER" { LOWER } }
@     { "MNU\->" { MNU\-> } }
@     { "MNU\<-" { MNU\<- } }
@     { "O\->S" { O\->S } }
@     { "sto" { sto } }
@     { "EJECT" { EJECT } }
@ }
\<< \-> lst
  \<<
    IF lst TYPE 6
==
    THEN lst RCL
    ELSE lst
    END
    \<< \-> itm
      \<<
        IF itm TYPE
5 ==
        THEN itm
        ELSE itm
O\->S itm 1 \->LIST 2
\->LIST
        END
      \>>
    \>> DOSUBS
    IF lst TYPE 6
==
    THEN lst STO
    END
  \>>
\>>
//
/Var mod
@ 1 based MOD
\<<
   \-> n
   \<<
      1 - n MOD 1 +
   \>>
\>>
//
/Var NOTE
@ play a note
@ duration & step
\<<
   12 / 2 SWAP ^ 220 * SWAP BEEP
\>>
//
/Var O\->S
@ object to string removing '
\<<
   IF
      DUP TYPE 19 ==                   @ built-in command
   THEN
      \->STR
   ELSE
      \->STR 2 OVER SIZE 1 - SUB       @ original programming
   END
\>>
//
/Var O\<-S
@ string to object preventing evaluation
\<<
   "'" SWAP + "'" + OBJ\->
\>>
//
/Var ODD
@ tests if odd
\<<
   2 / FP 0 \=/
\>>
//
/Var P.PRN
@ printer PICT size
\<<
   # A6h # 40h PDIM
\>>
//
/Var P.SPL
@ printer width, square height PICT size
\<<
   # A6h # 80h PDIM
\>>
//
/Var P.SQR
@ square PICT size
\<<
   # 83h # 83h PDIM
\>>
//
/Var P.STD
@ standard PICT size
\<<
   # 83h # 40h PDIM
\>>
//
/Var PAD0
@ number to zero padded comma formated string
@ uses: str\<-
\<<
   OVER
   IFERR XPON
   THEN
   END
   - 1 - OVER SIGN RCLF
   \-> N I S F
   \<<
      S ""
      IF N ABS 1 < -49 FS? -50 FS? OR AND
      THEN
         'I' DECR DROP
      END
      IF I 0 >
      THEN 1 I
         START
            "0" +
         NEXT
      END
      IF N 0 ==
      THEN
         "0" +
      END
      N ABS +
      15 SF str\<-
      F STOF
   \>>
\>>
//
/Var PARSE
@ parse a string at returns (ch 10) making list
\<<
   { }                                 @ empty list to build
   SWAP
   DO
      \-> s
      \<<
         s 10 CHR POS                  @ find return
         \-> n
         \<<
            IF
               n
            THEN
               s 1 n 1 - SUB +         @ get string head & add to list
               s n 1 + s SIZE SUB 0    @ leave string tail
            ELSE
               IF
                  s SIZE 0 >
               THEN                    @ if string tail left add to list
                  s +
               END
               1
            END
         \>>
      \>>
   UNTIL
   END
\>>
//
/Var PICTX
@ get max binary x & y
\<<
   PICT SIZE 2 \->LIST # 1h -
\>>
//
/Var PLAY
@ play list of notes
@ spacing, note, duration, note, duration, ...
@ uses: NOTE
\<<
   REVLIST OBJ\-> SWAP
   \-> d
   \<<
      2 / 1 SWAP
      START
         NOTE d WAIT
      NEXT
   \>>
\>>
//
/Var play
@ play list of notes
@ spacing, note, duration, note, duration, ...
@ uses: PLAY
\<<
   { .05 16 .2 19 .2 12 .2 0 .2 7 .4 }
   PLAY
\>>
//
/Var pos
@ POS with sart #
\<<
   \-> s p n
   \<<
      s n s SIZE SUB                   @ get tail to search
      p POS                            @ search
      IF
         DUP
      THEN                             @ adjust #
         n + 1 -
      END
   \>>
\>>
//
/Var PR21
@ printer output if flag 21 set
\<<
   IF 21 FS?
   THEN
      PR1
   END
\>>
//
/Var PROPER
@ convert to proper (title) case
@ > > > UNDER CONSTRICTION < < <
\<<
   LOWER
\>>
//
/Var PULL
@ recal & delete a list of vaiables
\<<
   1
   DO
      GETI
      \-> l i v
      \<<
         v RCL v PURGE v l i
      \>>
   UNTIL -64 FS?
   END
   DROP2
\>>
//
/Var rcl
@ recal variable & tag it
@ flg 5: optional RCL & PURGE
\<<
   \-> v
   \<<
      CASE
         5 v TYPE ==                   @ list
         THEN
            v 1
            \<<
               RCLF
               \-> f
               \<<
                  rcl f STOF
               \>>
            \>>
            DOSUBS
            5 CF
         END
         6 v TYPE ==                   @ global variable
         THEN
            v RCL v \->TAG
            IF
               5 FS?C
            THEN
               v
               IFERR                   @ purge var or dir
                  PURGE
               THEN
                  PGDIR
               END
            END
         END
         v                             @ default
      END
   \>>
\>>
//
/Var REDC
@ reduce fractions
@ 9/8 \-> 1+1/8
@ uses: IPFP
\<<
   RCLF
   \-> q f
   \<<
      STD
      IF
         q TYPE 9 ==
      THEN
         q OBJ\-> DROP2
         \-> n d
         \<<
            n d / IPFP d * 6 RND
            \-> a b
            \<<
               "'" a \->STR + "+" + b \->STR + "/" + d \->STR + "'" + OBJ\->
            \>>
         \>>
      ELSE
         q
      END
      f STOF
   \>>
\>>
//
/Var REN
@ rename a variable
\<<
   \-> a b
   \<<
      a RCL a PURGE b STO
   \>>
\>>
//
/Var RJST2
@ right justify
@ input: var, #
\<<
   SWAP
   \->STR                              @ convert to string
   DUP SIZE ROT SWAP -                 @ get difference
   \-> v n
   \<<
      IF
         n 0 >                         @ only pad if difference
      THEN
         CASE                          @ padding
            1 FS?C
            THEN
               "\031"                  @ ellipsis
            END
            2 FS?C
            THEN
               "-"                     @ dash
            END
            3 FS?C
            THEN
               "~"                     @ tilde
            END
            4 FS?C
            THEN
               "\127"                  @ block
            END
            5 FS?C
            THEN
               "\[]"                   @ square dot
            END
            " "                        @ default space
         END
         n RPT                         @ repeat selected pad chr
      ELSE
         ""                            @ no padding
      END
      v +                              @ add padding to string
   \>>
\>>
//
/Var ROWCOL
@ given N & col find 1 based row & col
\<<
   SWAP 1 -
   \-> c n
   \<<
      n c / IP                         @ row
      n OVER c * -                     @ col
      SWAP 1 + SWAP 1 +                @ 1 based
   \>>
\>>
//
/Var RPT
@ repeat character # times
\<<
   0 RND
   \-> c n
   \<<
      ""
      IF
         n 0 >
      THEN 1 n
         START
            c +
         NEXT
      END
   \>>
\>>
//
/Var RSTPRT
@ reset PRTPAR
\<<
   PATH HOME
   'PRTPAR' 2 "" PUT
   EVAL
\>>
//
/Var SRTA
@ sort all directories
@ uses: srta
\<<
   PATH HOME srta EVAL
\>>
//
/Var srta
@ recursive sort all directories
@ NOW PART OF dirsc #2
\<<
   15 TVARS \-> l
   \<<
      SRTD
      IF
         l SIZE 0 \=/
      THEN
         l
         1
         \<<
            GETI EVAL srta
         \>>
         DOSUBS
         UPDIR
      END
   \>>
\>>
//
/Var SRTD
@ sort directory
@ uses: srtd
\<<
   CLLCD "SORTING DIRECTORY" 4 DISP 13 0
   FOR n
      IF
         n 8 \=/
      THEN
         n TVARS srtd
      END -1
   STEP 8
   TVARS srtd 15 TVARS srtd
\>>
//
/Var srtd
@ sub for SRTD
@ sorts list
\<<
   IF
      DUP SIZE 0 \=/
   THEN
      SORT ORDER
   ELSE
      DROP
   END
\>>
//
/Var sto
@ store variable using tag
@ can be a list
\<<
   \-> v
   \<<
      CASE
         5 v TYPE ==                   @ list
         THEN v 1
            \<<
               33 SF sto
            \>>
            DOSUBS
         END
         6 v TYPE == 33 FC?C AND       @ global name
         THEN
            v STO
         END
         12 v TYPE ==                  @ tagged object
         THEN
            v OBJ\-> O\<-S
            IFERR
               STO
            THEN
               "\Ga" SWAP + O\<-S STO
            END
         END
         v "sto."                      @ default STO with #'s
         IFERR
            NSUB
         THEN
            0
         END
         + O\<-S STO
      END
   \>>
\>>
//
/Var str\->
@ convert comma formatted numeric string to number
\<<
   DUP SIZE OVER "," POS
   \-> S Z P
   \<<
      WHILE P
      REPEAT
         S 1 P 1 - SUB
         S P 1 + Z SUB +
         DUP "," POS 'P' STO
         'S' STO
      END
      S OBJ\->
   \>>
\>>
//
/Var str\<-
@ number to comma formatted string
@ used by PAD0
\<<
   IF 15 FC?C                          @ already string, used by PAD0
   THEN
      DUP SIGN SWAP ABS \->STR
   END
   DUP SIZE OVER "." POS \-> Q S Z P
   \<<
      IF S "'" POS
      THEN
         S 2 OVER SIZE 1 - SUB 'S' STO
      END
      IF P
      THEN
         P 1 -
      ELSE
         Z
      END
      \-> N
      \<<
         WHILE N 3 >
         REPEAT
         N 3 - 'N' STO
         S 1 N SUB "," + S N 1 + Z SUB +
         'S' STO
         S SIZE 'Z' STO
         END
      \>>
      IF Q 0 <
      THEN
         "-"
      ELSE
         "+"
      END
      S +
   \>>
\>>
//
/Var SYNC
@ synchronize HP48 directories
@ if dir not on server then creats it
\<<
   CLLCD PATH DUP DUP SIZE GET
   \-> p d
   \<<
      "Synching Directories" 4 DISP d 5 DISP
      p \->STR " EVAL" + "C" PKT d \->STR
      IF POS
      THEN
         "CRDIR" 7 DISP
         "CLEAR" "C" PKT DROP
         UPDIR
         SYNC                          @ recurse to create dir
         d \->STR " CRDIR " + d O\->S + "C" PKT DROP
         d EVAL
      END
   \>>
\>>
//
/Var tail
@ get list after position
\<<
   1 + OVER SIZE SUB
\>>
//
/Var TGCASE
@ toggle case
\<<
   DUP NUM
   \-> n
   \<<
      CASE
         n 65 \>= n 90 \<= AND
         THEN
            LWCASE
         END
         n 97 \>= n 122 \<= AND
         THEN
            UPCASE
         END
      END
   \>>
\>>
//
/Var tvars
@ gets all var types and sends
@ used for cataloging system
\<<
   CLLCD
   "TVARS" 3 DISP
   {}
   PATH 1 \->LIST +
   17 0
   FOR n
      CASE
         n 0 ==
         THEN
            "REAL"
         END
         n 1 ==
         THEN
            "CPLX"
         END
         n 2 ==
         THEN
            "STR"
         END
         n 3 ==
         THEN
            "REAL ARRY"
         END
         n 4 ==
         THEN
            "CPLX ARRY"
         END
         n 5 ==
         THEN
            "LIST"
         END
         n 6 ==
         THEN
            "GLBL"
         END
         n 7 ==
         THEN
            "LCL"
         END
         n 8 ==
         THEN
            "PRGM"
         END
         n 9 ==
         THEN
            "ALG"
         END
         n 10 ==
         THEN
            "BIN"
         END
         n 11 ==
         THEN
            "GPH"
         END
         n 12 ==
         THEN
            "TAG"
         END
         n 13 ==
         THEN
            "UNIT"
         END
         n 14 ==
         THEN
            "XLIB"
         END
         n 15 ==
         THEN
            "DIR"
         END
         n 16 ==
         THEN
            "LIB"
         END
         n 17 ==
         THEN
            "BKP"
         END
         "UNKN"
      END
      DUP                              @ leave type on stack for later
      4 DISP
      IF
         n 15 ==
      THEN                             @ don't need type
         DROP
      ELSE                             @ process var type
         n TVARS                       @ get var type
         IF
            DUP SIZE 0 ==
         THEN                          @ 0 list
            DROP2
         ELSE                          @ non 0 list
            1
            DO                         @ process var
               \-> i
               \<<
                  i GETI               @ get var
                  DUP 5 DISP           @ display
                  DUP BYTES 3 \->LIST  @ get var size
                  3 ROLLD              @ move to top of working list
               \>>
            UNTIL
               -64 FS?
            END
            DROP
            SIZE \->LIST +  1 \->LIST +  @ build var type list
            "" 5 DISP                  @ clear display
         END
      END
   -1 STEP
   'tmp' STO                           @ save list
   CLLCD 'tmp' SEND                    @ send
   'tmp' PURGE                         @ purge
\>>
//
/Var type
@ returns TYPE string
\<<
   \-> t
   \<<
      CASE
         0 t ==
         THEN
            "REL"
         END
         1 t ==
         THEN
            "CPX"
         END
         2 t ==
         THEN
            "CHR"
         END
         3 t ==
         THEN
            "REL ARY"
         END
         4 t ==
         THEN
            "CPX ARY"
         END
         5 t ==
         THEN
            "LST"
         END
         6 t ==
         THEN
            "GBL"
         END
         7 t ==
         THEN
            "LCL"
         END
         8 t ==
         THEN
            "PRG"
         END
         9 t ==
         THEN
            "ALG"
         END
         10 t ==
         THEN
            "BIN"
         END
         11 t ==
         THEN
            "GPH"
         END
         12 t ==
         THEN
            "TAG"
         END
         13 t ==
         THEN
            "UNT"
         END
         14 t ==
         THEN
            "XLB"
         END
         15 t ==
         THEN
            "DIR"
         END
         16 t ==
         THEN
            "LIB"
         END
         17 t ==
         THEN
            "BKP"
         END
         "unknown"
      END
   \>>
\>>
//
/Var UPPER
@ convert to upper case
\<<
   \-> s
   \<<
      "" 1 s SIZE
      FOR p
         s p DUP SUB NUM
         \-> n
         \<<
            n
            IF
               n 97 \>= n 122 \<= AND
            THEN
               32 -
            END
            CHR +
         \>>
      NEXT
   \>>
\>>
//
/Var UTIL
@ run utility prgms using CHOOSE
@ uses: home (custom menu)
@ shows items 4 at a time
\<<
   "PROGRAM"
   home
   TAIL                                @ remove first element, a dir
   1                                   @ active list
   IF
      CHOOSE
   THEN
      EVAL
   END
\>>
//
/Var VER
@ version w/calc name
\<<
   CLLCD
   "HP-48G" VERSION
   3 \->LIST
   1
   \<<
      IF 21 FS?
      THEN
         PR1
      END
      NSUB 4 + DISP
   \>>
   DOSUBS
   2 FREEZE
\>>
//
/Var VIEW
@ locked pview
\<<
   { } PVIEW
\>>
//
/Var VIEW0
@ unlocked pview
\<<
   { # 0h # 0h } PVIEW
\>>
//
/Var VIEW3
@ unlocked pview w/ 3 freeze
\<<
   VIEW0 3 FREEZE
\>>
//
/Var VIEW7
@ unlocked pview w/ 7 freeze
\<<
   VIEW0 7 FREEZE
\>>
//
/Var VLINE
@ drqaw line at x with spacing
@ uses: PICTX
\<<
   SWAP                                @ swap spacing
   0 R\->C C\->PX 1 GET                @ get binary x
   \-> S M
   \<<
      IF S 1 \<=
      THEN
         M # 0h 2 \->LIST M PICTX 2 GET 2 \->LIST LINE
      ELSE
         0 PICTX 2 GET B\->R
         FOR N
            M N R\->B 2 \->LIST PIXON
         S STEP
      END
   \>>
\>>
