// HP 48 Program Development Link Application
//
/Angle Degrees
/FractionMark .
/InstallDir { HOME MAIN ASTRO }
/AutoExec
//
/Var \->\->NOTES
@  { HOME MAIN ASTRO }

astronomical stuff

see
   ASTRO.XLS
      in the PDL directory
         C:\DOS\PDL\GX-HOME\MAIN\ASTRO
      Excel spreadsheet for data & mechanics
      'STARLST' & 'STARDAT' listS are here for export

I am working on a basic planetarium using the basis 58 navigational stars
   STARS or STARS.TXT or STARS.VAR
   use STARDAT to plot single stars & test my formulae

some vector & matrix work here for coordinate translation
   \GhAXIS
      rotate given 3D vector around selected axis by \Gh
      uses: \Ghaxis, \GhROT
   \GhROT
      rotate 2D vector by \Gh degrees
   NRM2D
      normal of a 2D vector or complex number
      use CROSS for 3D vectors
   C\->V
      complex to vector
   V\->C
      vector to complex
      3D leaves Z on the stack
   VECTOR
      takes 3D vector 'Vxyz' and calculates the axis angles

database
   STARS
      STARS database viewer & editor
      uses James Donnelly's Toolkit Title Browser
      add future insert functionality?
         easier to do the list with EXCEL then copy & paste
         sorting would be problematic
         I might just add stuff to end for later sorting
      learned some things about menus
         found some SYSEVALS too since menus for the most do not update
      keys:
         [ON] [--\->] [QUIT]
               quits the prgm
         [ENTER]
               position using curr time
         [EDIT]
               edit star data
         [VIEW]
               view star data
         [\|^STK]
               copy star data
         [POS]
               position asking for date & time
   STAREDT
      editor/viewer
      uses James Donnelly's Toolkit Data Browser
      keys:
         [ON] [--\->] [QUIT]
               quits the prgm
         [ENTER]
               saves when editing
               quits when viewing
         [SAVE]
               not displayed viewing
   STAR\->
      given index (not the star #) extract a list of that star
         & perform a translation based on lat, lon, & tim
         leaving star name & position
      this will be used by the planetarium prgm
         which is why it was made separate from STARS
         just scan 1 to STARLST SIZE & plot the stars
      FLAG 1
         set - displays data
         clr - data to stack
   ANGLE
      given date & time calculate star plotter angle
   STARLST
      list of names for STARDAT
   STARDAT
      the star database with 58 basic stars
      just reorganized & distance added
      list of lists sans the names

calendar calculations
   JD
      uses: MONTH, YEAR
      given a date & time calcuate the julian date
      JULIAN {HOME} uses the system clock
      I matched JD to JULIAN for ease of use
      SF 1 for astronomical JD
   MONTH
      same as DDAYS, sans the curr month days, uses a lookup table
   month
      lookup table, last entry is never used
   YEAR
      julian year calculation w/leap year flag
//
/Var \Gg
@ gamma
@ used by: VECTOR
74.498640433
//
/Var \Ga
@ alpha
@ used by: VECTOR
36.6992252004
//
/Var \Gb
@ beta
@ used by: VECTOR
57.6884667626
//
/Var \GhAXIS
@ rotate given 3D vector on selected axis by \Gh
@ maintains polar format
@ uses: \Ghaxis
\<<
   RCLMENU RCLF
   \-> m f
   \<<
      { ":X: " ":Y: " ":Z: " } TMENU
      "Vector Rotation"
      { "" V } INPUT OBJ\->
      m MENU f STOF
   \>>
   OBJ\->
   \-> a
   \<<
      CASE
         a "X" ==                      @ rotate around X
         THEN
            3 2 \Ghaxis                @ toward Z
         END
         a "Y" ==                      @ rotate around Y
         THEN
            3 1 \Ghaxis                @ toward Z
         END
         a "Z" ==                      @ rotate around Z
         THEN
            1 2 \Ghaxis                @ toward X
         END
         "Bad Input" 3 DISP 2 FREEZE snd
      END
  \>>
\>>
//
/Var \Ghaxis
@ used by: \GhAXIS
@ uses: \GhROT
\<<
   \-> v r i j
   \<<
      'v' i GET                        @ get axis values
      'v' j GET
      R\->C                            @ \->V2 will use polar setting
      r                                @ do not want angles
      \GhROT                           @ translate
      OBJ\-> DROP
      \-> a b
      \<<
         v i a PUT j b PUT             @ put the axis values
      \>>
   \>>
\>>
//
/Var \GhROT
@ rotate a 2D complex/vector n degrees using matrix transform
@ returns a 2D vector
@             | cos \Gh -sin \Gh |
@ | x' y' | = |              | * | x y |
@             | sin \Gh  cos \Gh |
\<<
   \-> v \Gh
   \<<
      \Gh COS \Gh SIN DUP NEG SWAP \Gh COS  @ build xlat matrix
      { 2 2 } \->ARRY
      v C\->V *                        @ translate
   \>>
\>>
//
/Var ANGLE
@ given date & time calculate star plotter angle
@ added minor adjustment, data used is 1975
@ used by: STAR\->
\<<
   JD 1.5 +                            @ adj to match astro jd
   1 365.24219879 INV + 360 * *
                                       @ minor adj here to match winstars
   lon -                               @ addtl adj can be added
   360 MOD                             @ modulus
\>>
//
/Var astro
@ custom menu
{
   { GROB 21 8 FFFFF1100001DAA3215A2161D429F15A2161DA2121FFFFF1 UPDIR }
   STARS    DATE  TIME  ANGLE    JD
   JULIAN   CVT   C\->V   V\->C      \GhROT  \GhAXIS
   NRM2D VECTOR
   { GROB 21 8 FFFFF1100001DFBF7150AF7150AF71DFBF71100001FFFFF1 ABITCH }
   { GROB 21 8 EFFFF020F180AF0EB020F180AF0EB0EFFFF0294290EFFFF0 EXE }
}
//
/Var CST
astro
//
/Var CVT
@ conversion menu
\<<
   {
      '1_yr'   '1_d'    '1_h'    '1_min'     '1_s'    '1_ticks'
      '1_yrsid'   '1_dsid'    '1_hsid'
   }
   TMENU
\>>
//
/Var DOW1
@ calculates day of week
@ uses: JD
@ see also: Donnelly's Toolkit DOW
\<<
   0 JD IP                             @ calc julian date
   5 + 7 MOD                           @ week modulus
   1 +                                 @ offset from 0
\>>
//
/Var DOY1
@ calculates day of year
@ see also: Donnelly's Toolkit DOY
\<<
   DUP 100 * FP 100 /                  @ get year
   1.01 +                              @ set to 1 Jan
   SWAP DDAYS 1 +                      @ calculate delta days
\>>
//
/Var dsid
@ conversion factor
'24_hsid'
//
/Var hsid
@ Lconversion factor
'4.16666666667E-2_dsid'
//
/Var JD
@ julian date calculation from date & time on the stack
@ uses: MONTH, YEAR
@ different than JULIAN in the HOME dir which uses clock TICKS
@     the result is the same
@ YEAR returns an extra day for leap years
@     so months < 3 in a leap year need one less day
@     I missed this the first time
@     probably best to double check this number before any calculations
@ unfortunately calendars are not linear as julian dates are
@     that is why astronomical calculations use julian dates
@ I did this as an exercise for any program HP48 or PC
@     I did not want dependency on an operating system
@     that & I was curious about calendar mechanics
@     I have notes somewhere from extensive research
\<<
   RCLF
   \-> t f                             @ save time & flags
   \<<
      -41 SF -42 SF                    @ 24 hour & dd.mmyyy
      IPFP                             @ day
      100 *
      IPFP                             @ month
      10000 *                          @ year
      f STOF                           @ restore flags
      \-> d m y                        @ save day month year
      \<<
         y YEAR                        @ YEAR sets a leap flag
         m MONTH +                     @ lookup table
         d +
         t HMS\-> 24 / +
         IF m 3 < 11 FS?C AND          @ leap year month compensation
            THEN
               1 -                     @ -1 for pre leap condition
         END
         IF 12 FS?                     @ astronomical julian date
            THEN
               1721059.5 +             @ from WinStars, might be 5hr off
         END
      \>>
   \>>
\>>
//
/Var lat
@ latitude
35
//
/Var LATLON
@ input latitude & longitude
@ uses TAGSTO
@ used by: STARDAT
\<<
   "Enter Position"
   lat 'lat' \->TAG \->STR 10 CHR + lon 'lon' \->TAG \->STR +
   { -1 7 } V
   3 \->LIST
   28 MENU CLLCD INPUT
   OBJ\-> TAGSTO TAGSTO
\>>
//
/Var lon
@ longitude
0
//
/Var month
@ month lookup table with non-leap values & running total
@ the last entry is never used and is included for completeness
@ used by: MONTH
@  #   days    sum
[
[  1     31     31 ]
[  2     28     59 ]
[  3     31     90 ]
[  4     30    120 ]
[  5     31    151 ]
[  6     30    181 ]
[  7     31    212 ]
[  8     31    243 ]
[  9     30    273 ]
[ 10     31    304 ]
[ 11     30    334 ]
[ 12     31    365 ]
]
//
/Var MONTH
@ calculate # days up to the beginning of month given
@ uses a table instead of DDAYS
@ uses: month
@ used by: JD
\<<
   1 -                                 @ set index: 0 to #
   \-> m
   \<<
      IF
         m 0 >
      THEN
         'month' m 3 2 \->LIST GET     @ table lookup
      ELSE
         0
      END
   \>>
\>>
//
/Var NRM2D
@ normal of a 2D complex or vector
@ for 3D vector normals use CROSS
\<<
   \-> v
   \<<
      IF
         v TYPE 1 ==                   @ complex ?
      THEN
         v C\->R NEG SWAP R\->C
      ELSE
         IF
            v TYPE 3 ==                @ vector / matrix ?
         THEN
            IF
               v SIZE DUP
               SIZE 1 ==               @ vector ?
               SWAP
               1 GET 2 ==              @ 2D ?
               AND
            THEN
               v OBJ\-> DROP NEG SWAP { 2 } \->ARRY
            END
         ELSE
            v                          @ not complex / vector return obj
         END
      END
   \>>
\>>
//
/Var SHA\->
@ convert LHA to azimuth
\<<
   HMS\-> 360 SWAP -
\>>
//
/Var SKYVIEW
@ planetarium, matches star plotter
@ uses: LATLON, STAR\->, STARLST, GDISP
\<<
   LATLON DATE TIME RCLF
   \-> d t f
   \<<
      DEG SPHERE POLAR 10 CF           @ various settings
      # 131d # 131d PDIM               @ double height
      15 15 SCALE
      #5d RES                          @ RES does not affecr ARC
      (0,0) CENTR
      { # 0d # 32d } PVIEW
      ERASE DRAX                       @ axii & radii
      (0,0) 45 0 360 ARC
      (0,0) 90 0 360 ARC
      d t TSTR 1 1 1 GDISP 1 FIX       @ date, time, & plotter azimuth
      d t ANGLE "PLT" \->TAG 2 1 1 GDISP
      1 STARLST SIZE                   @ get data size
      FOR n
         d t n STAR\->                 @ get star data
         \-> l a e m
         \<<
         IF e 0 \>=                    @ above horizon ?
            THEN
               90 e -                  @ to polar
               450 a -                 @ rot 90\^o
               \->V2 V\->C             @ to complex preserving angle
               \-> p                   @ point
               \<<
                  p 5 m - 0 360 ARC    @ corr for mag & draw circle
                  p C\->PX
                  \-> px               @ pixel
                  \<<
                     px PIXON          @ dot
                     PICT px           @ build label
                     OBJ\-> ROT 4 -
                     ROT 4 + ROT \->LIST
                     l DTAG 1 3 SUB
                     1 \->GROB GOR
                  \>>
               \>>
         END
      \>>
      NEXT
      f STOF
      { } PVIEW
   \>>
\>>
//
/Var STAR\->
@ given date, time, & data index calculate & display star position
@ does not freeze display
@ flag 10 clr=data set=disp
@ star data to azimuth & elevation using lat, lon & time
@ cooresponds to the STAR FINDER navigation tool
@ uses internal DATE, TIME, & r,\Gh,\248 \<-\-> x,y,z conversions
@ used by: STARS
@ uses: STARLST, STARDAT, ANGLE
\<<
    RCLF
   \->  dt tm i f
   \<<
      'STARLST' i GET                  @ get star name
      'STARDAT' i GET OBJ\-> DROP      @ get star data
      dt tm ANGLE                      @ get plotter angle
      \-> l n a e m d p
      \<<
         1                             @ unit vector
         a p -                         @ position
         IF DUP 0 <                    @ correct negative
            THEN 360 +
         END
         90 e -                        @ elv to polar
         DEG SPHERE \->V3              @ r,\Gh,\248 to vector
         RECT V\->                     @ vector to x,y,z
         \-> x y z                     @ translate
         \<<
            z x \->V2                  @ vector to rotate
            lat 90 -                   @ cvt lat to polar
            \GhROT                     @ rotate vector
            V\-> y ROT \->V3           @ make x,y,z vector
         \>>
         SPHERE V\->                   @ vector to r,\Gh,\248
         \-> r \Ga \Gb
         \<<
            IF 10 FS?                  @ flg 1 disp/data
               THEN
                  "Star Position"
                  dt tm TSTR           @ time string
            END
            l i 2 \->STRN  \->TAG      @ star name
            180 \Ga - "AZI" \->TAG     @ star finder conversion
            90 \Gb - "ELV" \->TAG      @ polar to elv
            m "MAG" \->TAG
            IF 10 FS?
               THEN
                  p "PLT" \->TAG       @ star finder azimuth
                  CLLCD
                  7 1 FOR i
                     i DISP
                  -1 STEP
            END
         \>>
      \>>
      f STOF
   \>>
\>>
//
/Var STARDAT
@ the 58 basic navigational stars found on the Planisphere navigational tool
@ the azimuth needs inverting for sky view
@ azm matches the Star Plotter
@ data for STARLST
@ two lists for complete star data: STARLST & STARDAT
@ both of which were exported from C:\DOS\PDL\GX-HOME\MAIN\ASTRO\ASTRO.XLS
@ { #    azm    elv  mag   dist }
{
{ 07  044.57 -40.30  3.1   120.0 }
{ 05  024.43 -57.24  0.6    72.0 }
{ 30  186.65 -63.10  1.1   220.0 }
{ 19  104.66 -28.97  1.6   350.0 }
{ 10  068.98  16.51  1.1    64.0 }
{ 32  193.51  55.96  1.7    49.0 }
{ 34  206.89  49.31  1.9   190.0 }
{ 55  332.06 -46.96  2.2    90.0 }
{ 15  084.05 -01.20  1.8   410.0 }
{ 25  141.90 -08.66  2.2   200.0 }
{ 41  233.67  26.71  2.3    76.0 }
{ 01  002.10  29.09  2.2   120.0 }
{ 51  297.70  08.87  0.9    16.0 }
{ 02  006.57 -42.31  2.4    93.0 }
{ 42  247.35 -26.43  1.2   250.0 }
{ 37  213.92  19.18  0.2    37.0 }
{ 43  252.17 -69.03  1.9   130.0 }
{ 22  125.63 -59.51  1.7   350.0 }
{ 13  081.28  06.35  1.7   250.0 }
{ 16  088.79  07.41  0.5   300.0 }
{ 17  095.99 -52.70 -0.9   230.0 }
{ 12  079.17  46.00  0.2    46.0 }
{ 53  310.36  45.28  1.3   600.0 }
{ 28  177.26  14.57  2.2    42.0 }
{ 04  010.90 -17.99  2.2    57.0 }
{ 27  165.93  61.75  2.0   100.0 }
{ 14  081.57  28.61  1.8   130.0 }
{ 47  269.15  51.49  2.4   150.0 }
{ 54  326.05  09.87  2.5   250.0 }
{ 56  344.41 -29.62  1.3    23.0 }
{ 31  187.79 -57.11  1.6    72.0 }
{ 29  183.95 -17.54  2.8   136.0 }
{ 35  210.96 -60.37  0.9   200.0 }
{ 06  031.79  23.46  2.2    76.0 }
{ 48  276.04 -34.38  2.0   163.0 }
{ 40  222.68  74.16  2.2   100.0 }
{ 57  346.19  15.21  2.6   100.0 }
{ 08  045.57  04.09  2.8  1100.0 }
{ 36  211.67 -36.37  2.3    55.0 }
{ 24  138.30 -69.72  1.8    86.0 }
{ 09  051.08  49.86  1.9   130.0 }
{ 50  283.82 -26.30  2.1   150.0 }
{ 52  306.41 -56.74  2.1   250.0 }
{ 58  037.95  89.26  2.0   450.0 }
{ 21  116.33  28.03  1.2    33.0 }
{ 20  114.83  05.23  0.5    11.0 }
{ 46  263.73  12.56  2.1    67.0 }
{ 26  152.09  11.97  1.3    67.0 }
{ 11  078.63 -08.20  0.3   500.0 }
{ 38  219.90 -60.84  0.1     4.3 }
{ 44  257.59 -15.72  2.6    69.0 }
{ 03  010.13  56.54  2.5   360.0 }
{ 45  263.40 -37.10  1.7   200.0 }
{ 18  101.29 -16.72 -1.6     8.6 }
{ 33  201.30 -11.16  1.2   155.0 }
{ 23  137.00 -43.43  2.2   200.0 }
{ 49  279.23  38.78  0.1    27.0 }
{ 39  222.72 -16.04  2.9    66.0 }
}
//
/Var STAREDT
@ given data index edit star data
@ viewing: [ENTER] = QUIT
@ editing: [ENTER] = SAVE
@ [ON] = QUIT
@ used by: STARS
@ uses: STARLST, STARDAT, James Donnelly's Toolkit
\<<
   \-> n f
   \<<
      {
         "     Name: "
         "        #: "
         "  Azimuth: "
         "Elevation: "
         "Magnitude: "
         " Distance: "
      }
      'STARLST' n GET                  @ get name
      'STARDAT' n GET +                @ get data
      { "SAVE" "--\->" "--\->" "--\->" "--\->" "QUIT" }
      IF f NOT                         @ do not edit
         THEN
            1
            GROB 21 8 000000FAB771EEB3E13817B1F60CB1DE1F008FBBB1DBBFB1
            PUT
      END
      { 2 1 1 1 "" }
      0 0
      \-> l d m c i r
      \<<
         DO
            'c'
            STD
            IF f                       @ edit/view titles
               THEN
                  5 n "Edit Star" \->TAG \->STR PUT
               ELSE
                  4 0 PUTI
                  n "View Star" \->TAG \->STR PUT
            END
            l d m c DBR
            'r' STO                    @ save return
            'i' STO                    @ save index
            'c' STO                    @ save ctrl
            IF f                       @ save data
               THEN
                  'd' STO
            END
            CASE
               r  0 ==                 @ [ON] cancel/quit
               r -2 == OR
               r -3 == OR
               r -4 == OR
               r -5 == OR
               r -6 == OR
               THEN
                  0 'f' STO
                  1
               END
               r  1 ==                 @ [ENTER] save/quit
               r -1 == OR
               THEN
                  1
               END                     @ menu items
               0                       @ continue
            END
         UNTIL
         END
         IF f THEN                     @ save data
            d OBJ\-> DROP
            5 \->LIST
            'STARDAT' n ROT PUT
            'STARLST' n ROT PUT
         END
      \>>
   \>>
\>>
//
/Var STARLST
@ names for STARDAT
@ two lists for complete star data: STARLST & STARDAT
{
"Acamar"
"Achernar"
"Acrux"
"Adhara"
"Aldebaran"
"Alioth"
"Alkaid"
"AlNair"
"Alnilam"
"Alphard"
"Alphecca"
"Alpheratz"
"Altair"
"Ankaa"
"Antares"
"Arcturus"
"Atria"
"Avior"
"Bellatrix"
"Betelgeuse"
"Canopus"
"Capella"
"Deneb"
"Denebola"
"Diphda"
"Dubhe"
"Elnath"
"Eltanin"
"Enif"
"Formalhaut"
"Gacrux"
"Gienah"
"Hadar"
"Hamal"
"KausAustralis"
"Kochab"
"Markab"
"Menkar"
"Menkent"
"Miaplacidus"
"Mirfak"
"Nunki"
"Peacock"
"Polaris"
"Pollux"
"Procyon"
"Rasalhague"
"Regulus"
"Rigel"
"RigelKent"
"Sabik"
"Schedar"
"Shaula"
"Sirius"
"Spica"
"Suhail"
"Vega"
"Zubenelgenubi"
}
//
/Var STARS
@ navigational stars database utility
@ [ENTER] = position
@     menu [POS] asks for time
@ [ON] = quit
@ menu items = whatever they say
@ freshly reorganized using a revised database eliminating duplication
@     and revised programming
@ uses: STAREDT, STARDAT, STARLST, James Donnelly's Toolkit
@ various ways to control menus inside a prgm
@     for the most part menus do not update until the prgm ends
@     both update the menu:
@        INPUT
@              allows menu keys for input
@              28 MENU the edit menu works
@              & use menu to get back to the TMENU if used
@        -n WAIT
@              why -n & not 0?
@     #4E2CFh SYSEVAL    turn menu off
@     #4E347h SYSEVAL    turn menu on
@     #3A1FCh SYSEVAL    update menu, the most useful for TMENU
\<<
   CLLCD
   RCLF RCLMENU LATLON
   { "EDIT" "VIEW" "\|^STK" "\->POS" "\->LOC" "QUIT" }
   { 1 1 "" }
   0 0
   \-> fl mu m c i r
   \<<
      fl STOF                          @ restore flags
      DO
         'c' 3
         DATE TIME ANGLE "Nav Stars"   @ build title w/angle
         \->TAG 1 FIX \->STR PUT       @ & update title
         STARLST m c
         TBR
         'r' STO 'i' STO 'c' STO       @ save TBR data
         CASE
            r  0 ==                    @ [ON] or menu key quit
            r -6 ==  OR
            THEN
               1
            END
            r -1 ==                    @ edit
            THEN
               i 1 STAREDT
               0
            END
            r -2 ==                    @ view
            THEN
               i 0 STAREDT
               0
            END
            r -3 ==                    @ stack
            THEN
               'STARLST' i GET
               'STARDAT' i GET +
               0
            END
            r  1 ==                    @ [ENTER] or meny key position
            r -4 ==  OR
            THEN

               IF r 1 ==
                  THEN                 @ get curr time
                     DATE TIME
                  ELSE                 @ ask for time
                     CLLCD
                     STD
                     "Enter Time"
                     ":DAT: " DATE \->STR +
                     10 CHR +
                     ":TIM: " TIME \->STR +
                     +
                     { -1 7 } V
                     3 \->LIST
                     -40 SF 28 MENU INPUT OBJ\->
               END
               10 SF i STAR\->
               {
                  "Press" "Any" "Key" "To" "Cont"
                  GROB 21 8 000000FAB771EEB3E13817B1F60CB1DE1F008FBBB1DBBFB1
               }
               TMENU
               -40 CF
               #3A1FCh SYSEVAL         @ update menu
               0 WAIT DROP             @ unless asking for time
               0                       @ the clck will not disp
            END                        @ something with Donnelly's lib
            r -5 ==                    @ new location
            THEN
               LATLON
               0
            END
            0                          @ so the clock needs to be off
         END
      UNTIL
      END
      fl STOF mu MENU
   \>>
\>>
//
/Var ticks
@ conversion factor
'1.220703125E-4_s'
//
/Var VECTOR
@ axis angles from vector
@ uses: Vxyz, \Ga, \Gb, \Gg
\<<
   RCLF
   \-> f
   \<<
      'Vxyz' STO Vxyz ABS Vxyz OBJ\-> DROP
      \-> r x y z
      \<<
         x r / ACOS '\Ga' STO
         y r / ACOS '\Gb' STO
         z r / ACOS '\Gg' STO
      \>>
      2 FIX
      Vxyz 'Vxyz' \->TAG 3 DISP
      \Ga '\Ga' \->TAG 5 DISP
      \Gb '\Gb' \->TAG 6 DISP \Gg '\Gg' \->TAG 7 DISP
      2 FREEZE f STOF
   \>>
\>>
//
/Var Vxyz
@ 3D vector
@ used by: VECTOR
[ 3 2 1 ]
//
/Var YEAR
@ calculate julian years
@ used by: JD
@ I did extensive calendar mechanics research to find these numbers
@     it took me some time to resolve calendar mechanics
@     it is even harder post 11 Sep 2001 to find information
@     then Wikipedia is unecessarily complex for technical stuff
@     Wikipedia is full or prima-donnas & government interference
\<<
   \-> y
   \<<
      y 365 *                          @ 365 days per year
      y 4 / IPFP                       @ every 4 years a day is gained
      IF 0 ==                          @ set/clear leap year flag
         THEN
            11 SF
         ELSE
            11 CF
      END
      y -100 / IP + +                  @ every 100 years a day is lost
      y 400 / IP +                     @ every 400 years a day is gained
   \>>
\>>
//
/Var yrsid
@ conversion factor
'365.25636042_d'
